/*  Wilbur - file indexing and search utility - CD launch program
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// CDWilbur.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "CDWilbur.h"
#include "CDWilburDlg.h"
#include "updateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Registery functions

BOOL regGetBinary( HKEY hBaseKey, CString sSubKey, CString sVarName, void* pBuffer, DWORD lSize )
{ 
	HKEY hKeySoftware;
	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		sSubKey = "RedTree\\Wilbur\\" + sSubKey;

		lResult = RegOpenKeyEx( hKeySoftware, sSubKey,
		                        0, KEY_READ, &hSubKey );

		if( lResult == ERROR_SUCCESS )
		{
			lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
			                           (LPBYTE) pBuffer, &lSize );


			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return (lResult == ERROR_SUCCESS );
}

int regGetInt( HKEY hBaseKey, CString sSubKey, CString sVarName, int nDefault )
{ 
	HKEY hKeySoftware;

	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		sSubKey = "RedTree\\Wilbur\\" + sSubKey;

		lResult = RegOpenKeyEx( hKeySoftware, sSubKey,
		                        0, KEY_READ, &hSubKey );

		if( lResult == ERROR_SUCCESS )
		{
			unsigned long nSize = sizeof( DWORD );
			int nReturn;

			lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
			                           (LPBYTE) &nReturn, &nSize );

			if( lResult == ERROR_SUCCESS )
				nDefault = nReturn;

			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return nDefault;
}

CString regGetString( HKEY hBaseKey, CString sSubKey, CString sVarName, CString sDefault )
{ 
	HKEY hKeySoftware;

	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		sSubKey = "RedTree\\Wilbur\\" + sSubKey;

		lResult = RegOpenKeyEx( hKeySoftware, sSubKey,
		                        0, KEY_READ, &hSubKey );

		if( lResult == ERROR_SUCCESS )
		{
			unsigned long nSize;

			lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
			                           NULL, &nSize );

			if( lResult == ERROR_SUCCESS )
			{
				CString sVar;
				lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
										   (LPBYTE) sVar.GetBuffer( nSize ), &nSize );
				sVar.ReleaseBuffer();

				if( lResult == ERROR_SUCCESS )
					sDefault = sVar;
			}

			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return sDefault;
}

CString regGetIEVersion()
{
	HKEY hBaseKey = HKEY_LOCAL_MACHINE;
	CString sSubKey = "Microsoft\\Internet Explorer";
	CString sVarName = "Build";
	CString sResult;

	HKEY hKeySoftware;

	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		lResult = RegOpenKeyEx( hKeySoftware, sSubKey,
		                        0, KEY_READ, &hSubKey );

		if( lResult == ERROR_SUCCESS )
		{
			unsigned long nSize;

			lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
			                           NULL, &nSize );

			if( lResult == ERROR_SUCCESS )
			{
				CString sVar;
				lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
										   (LPBYTE) sVar.GetBuffer( nSize ), &nSize );
				sVar.ReleaseBuffer();

				if( lResult == ERROR_SUCCESS )
					sResult = sVar;
			}

			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return sResult;
}

BOOL regPutBinary( HKEY hBaseKey, CString sSubKey, CString sVarName, void* pBuffer, DWORD lSize )
{ 
	HKEY hKeySoftware;
	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		DWORD dwDisp;

		sSubKey = "RedTree\\Wilbur\\" + sSubKey;

		lResult = RegCreateKeyEx( hKeySoftware, sSubKey,
		                        0, "Per-User Data", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
		                        NULL, &hSubKey, &dwDisp );

		if( lResult == ERROR_SUCCESS )
		{
			lResult = RegSetValueEx( hSubKey, sVarName, 0, REG_BINARY,
			                           (LPBYTE) pBuffer, lSize );


			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return (lResult == ERROR_SUCCESS );
}

BOOL regPutInt( HKEY hBaseKey, CString sSubKey, CString sVarName, int nVar )
{ 
	HKEY hKeySoftware;
	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		DWORD dwDisp;

		sSubKey = "RedTree\\Wilbur\\" + sSubKey;
		lResult = RegCreateKeyEx( hKeySoftware, sSubKey,
		                        0, "Per-User Data", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
		                        NULL, &hSubKey, &dwDisp );

		if( lResult == ERROR_SUCCESS )
		{
			lResult = RegSetValueEx( hSubKey, sVarName, 0, REG_DWORD,
			                           (LPBYTE) &nVar, sizeof( DWORD ) );


			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return (lResult == ERROR_SUCCESS );
}

BOOL regPutString( HKEY hBaseKey, CString sSubKey, CString sVarName, CString sVar )
{
	HKEY hKeySoftware;
	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		DWORD dwDisp;

		sSubKey = "RedTree\\Wilbur\\" + sSubKey;

		lResult = RegCreateKeyEx( hKeySoftware, sSubKey,
		                        0, "Per-User Data", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
		                        NULL, &hSubKey, &dwDisp );

		if( lResult == ERROR_SUCCESS )
		{
			lResult = RegSetValueEx( hSubKey, sVarName, 0, REG_SZ,
			                           (LPBYTE) ( (LPCSTR) sVar), sVar.GetLength() + 1 );


			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return (lResult == ERROR_SUCCESS );
}

CString regGetFixString( CString sSubKey, CString sVarName, CString sDefault )
{
	CString sReturn = regGetString( HKEY_LOCAL_MACHINE, sSubKey, sVarName, "" );
	if( sReturn.IsEmpty() )
	{
		sReturn = regGetString( HKEY_CURRENT_USER,  sSubKey, sVarName, sDefault );
		regPutString( HKEY_LOCAL_MACHINE,  sSubKey, sVarName, sReturn );
	}

	return sReturn;
}

int regGetFixInt( CString sSubKey, CString sVarName, int nDefault )
{
	int nReturn = regGetInt( HKEY_LOCAL_MACHINE, sSubKey, sVarName, -32767 );
	if( nReturn == -32767 )
	{
		nReturn = regGetInt( HKEY_CURRENT_USER,  sSubKey, sVarName, nDefault );
		regPutInt( HKEY_LOCAL_MACHINE,  sSubKey, sVarName, nReturn );
	}

	return nReturn;
}

/////////////////////////////////////////////////////////////////////////////
// CCDWilburApp

BEGIN_MESSAGE_MAP(CCDWilburApp, CWinApp)
	//{{AFX_MSG_MAP(CCDWilburApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCDWilburApp construction

CCDWilburApp::CCDWilburApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCDWilburApp object

CCDWilburApp theApp;

CCDWilburApp* thisApp() { return &theApp; }

/////////////////////////////////////////////////////////////////////////////
// CCDWilburApp initialization

BOOL CCDWilburApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	m_sPath = m_pszHelpFilePath;
	int nIndex = m_sPath.ReverseFind( '\\' );
	if( nIndex != -1 )
		m_sPath = m_sPath.Left( nIndex );

	CString sIni = m_sPath + "\\CDWilbur.ini";

	try
	{
		CStdioFile iniFile( sIni, CFile::modeRead | CFile::shareDenyNone );
	
		CString sLine;
		while( iniFile.ReadString( sLine ) )
		{
			int nIndex = sLine.Find( '=' );
			if( nIndex != -1 )
			{
				CString sKey = sLine.Left( nIndex );
				sKey.MakeLower();
				if( !sKey.IsEmpty() )
					m_dictionary.SetAt( sKey, sLine.Mid( nIndex + 1 ) );
			}
		}
	}
	catch( ... )
	{
		AfxMessageBox("Could not read the CDWilbur.ini file - not good!");
	}

	CCDWilburDlg dlg;
	m_pMainWnd = &dlg;

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

CString CCDWilburApp::startDir()
{
	return m_sPath;
}

void CCDWilburApp::checkInit()
{
	CString sPath = m_sPath;

	DWORD dwTime = regGetFixInt( "Settings", "IDNumber", 0 );

	CString sIndexes = getValue("indexdir");
	if( sIndexes.IsEmpty() )
		sIndexes = sPath + "\\indexes";
	else
		sIndexes = sPath + "\\" + sIndexes;

	CString sVersion = regGetString( HKEY_LOCAL_MACHINE, "Settings", "Version", "" );

	if( !dwTime )
	{
		if( sVersion.IsEmpty() )
		{
			CTime tmCurrent = CTime::GetCurrentTime();
			dwTime = tmCurrent.GetTime();
			__asm ror dwTime,15
			dwTime ^= 0xadadadad;
			regPutInt( HKEY_LOCAL_MACHINE, "Settings", "IDNumber", dwTime );

			regPutString( HKEY_CURRENT_USER, "Options", "IndexPath", sIndexes );

			CString sInitialIndex = sIndexes + "\\" + getValue("initialindex");
			regPutString( HKEY_CURRENT_USER, "Recent File List", "File1", sInitialIndex );

			CString sTemp = getValue("tempdir");
			if( sTemp.IsEmpty() )
				sTemp = "C:\\temp\\";

			regPutString( HKEY_LOCAL_MACHINE, "Zip Options", "TempDir", sTemp );

			int nOutline = 1;
			if( getValue( "outline" ) == "0" )
				nOutline = 0;
			regPutInt( HKEY_CURRENT_USER, "Contents View", "Outline", nOutline );

			CString sEditor = getValue("editor");
			if( !sEditor.IsEmpty() )
			{
				sEditor = sPath + '\\' + sEditor;
				regPutString( HKEY_LOCAL_MACHINE, "Options", "editor", sEditor );
			}

			CString sNumber = getValue("near");
			if( !sNumber.IsEmpty() )
				regPutString( HKEY_LOCAL_MACHINE, "Options", "near", atoi(sNumber) );

			sNumber = getValue("tabsize");
			if( !sNumber.IsEmpty() )
				regPutString( HKEY_LOCAL_MACHINE, "Contents View", "TabWidth", atoi(sNumber) );

			sNumber = getValue("wordwrap");
			if( !sNumber.IsEmpty() )
				regPutString( HKEY_LOCAL_MACHINE, "Contents View", "WordWrap", atoi(sNumber) );
		}
	}


	if( sVersion[0] != '2' )
	{
		CString sIEVersion = regGetIEVersion();
		
		if( sIEVersion.IsEmpty() || sIEVersion.GetLength() < 5 || (sIEVersion[ 0 ] != '4' && sIEVersion [ 0 ] != '5' ) ) 
		{
			if( AfxMessageBox("Your system appears to need some Microsoft supplied updates\n\nDo you wish me to install those now?", MB_YESNO) == IDYES )
			{
				// put something in registry so this isn't repeated after reboot
				regPutString( HKEY_LOCAL_MACHINE, "Settings", "Version", "2Fake" );
				CString sAxdist = sPath + "\\wilbur\\oadist.exe";
				CUpdateDlg updateDlg;
				unsigned long nShellReturn;
				nShellReturn = (unsigned long) ShellExecute( NULL, NULL, sAxdist, NULL, NULL, SW_SHOW );

				if( nShellReturn <= 32 )
				{
					CString sMsg;
					sMsg.Format("I could not run system update file axdist.exe\nThe system reported error number %d\n",
						nShellReturn);
					sMsg += "\nPlease report this error to us!\n\n";
					sMsg += "You may not need this update, so we will proceed without it";
					AfxMessageBox( sMsg );
				}
				else
					updateDlg.DoModal();


				CString sComupdate = sPath + "\\wilbur\\40comupd.exe";
				nShellReturn = (unsigned long) ShellExecute( NULL, NULL, sComupdate, NULL, NULL, SW_SHOW );

				if( nShellReturn <= 32 )
				{
					CString sMsg;
					sMsg.Format("I could not run system update file 40comupd.exe\nThe system reported error number %d\n",
						nShellReturn);
					sMsg += "\nPlease report this error to us!\n\n";
					sMsg += "You may not need this update, so we will proceed without it";
					AfxMessageBox( sMsg );
				}
				else
					return;
			}
		}
	}

//	CString sWilbur = '\"' + sPath + "\\wilbur\\wilbur.exe" + '\"';
	CString sWilbur = sPath + "\\wilbur\\wilbur.exe";
	CString sIndex = getValue("index");
	unsigned long nShellReturn;
	if( !sIndex.IsEmpty() )
	{
		sIndex = '\"' + sIndexes + '\\' + sIndex + '\"';
		nShellReturn = (unsigned long) ShellExecute( NULL, NULL, sWilbur, sIndex, NULL, SW_SHOW );
	}
	else
		nShellReturn = (unsigned long) ShellExecute( NULL, NULL, sWilbur, NULL, NULL, SW_SHOW );

	if( nShellReturn <= 32 )
	{
		CString sMsg;
		sMsg.Format("I could not run Wilbur for some reason\nThe system reported error number %d\n",
			nShellReturn);
		sMsg += "\nPlease report this error to us!\n\n";
		sMsg += "In the mean time you might try running Wilbur directly from the Wilbur folder";
		AfxMessageBox( sMsg );
	}
}

CString CCDWilburApp::getValue( const CString& sKey )
{
	CString sValue;
	if( m_dictionary.Lookup( sKey, sValue ) != 0 ) 
		return sValue; 
	else 
		return ""; 
}
