/*  Wilbur - file indexing and search utility
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// CommandDialog.cpp : implementation file
//

#include "stdafx.h"
#include "wilbur.h"

#if !defined(__COMMANDDIALOG_H__)
#include "CommandDialog.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCommandDialog dialog


CCommandDialog::CCommandDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CCommandDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCommandDialog)
	m_sCommand = _T("");
	m_bSingleExec = FALSE;
	m_bPause = FALSE;
	m_bPreview = FALSE;
	//}}AFX_DATA_INIT
}


void CCommandDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommandDialog)
	DDX_Control(pDX, IDC_COMMAND, m_cbCommand);
	DDX_CBString(pDX, IDC_COMMAND, m_sCommand);
	DDX_Check(pDX, IDC_SINGLE_EXEC, m_bSingleExec);
	DDX_Check(pDX, IDC_PAUSEAFTER, m_bPause);
	DDX_Check(pDX, IDC_PREVIEW, m_bPreview);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCommandDialog, CDialog)
	//{{AFX_MSG_MAP(CCommandDialog)
	ON_BN_CLICKED(IDC_SAVECOMMAND, OnSavecommand)
	ON_BN_CLICKED(IDC_DELETECOMMAND, OnDeletecommand)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommandDialog message handlers

BOOL CCommandDialog::OnInitDialog() 
{
	m_bPreview = TRUE;
	m_bPause = TRUE;

	CDialog::OnInitDialog();

	CString sCommands = regGetString( HKEY_CURRENT_USER, "Command History", "Commands", "" );

	int nEOL;
	while( (nEOL = sCommands.Find('\n')) > 0 )
	{
		m_cbCommand.AddString( sCommands.Left( nEOL ) );
		sCommands = sCommands.Mid( nEOL + 1 );
	}

/*	
	int nItems = regGetInt( HKEY_CURRENT_USER, "Command History", "Count", 0 );
	
	for( int i = 0; i < nItems; i++ )
	{
		CString sItem;
		sItem.Format("Command_%d", i );
		CString sCommand = regGetString( HKEY_CURRENT_USER, "Search History", sItem, "" );
		m_cbCommand.AddString( sCommand );
	}
*/	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCommandDialog::OnSavecommand() 
{
	UpdateData( TRUE );
	if( m_cbCommand.FindStringExact( -1, m_sCommand ) == CB_ERR )
		m_cbCommand.AddString( m_sCommand );

	updateRegistry();
}

void CCommandDialog::OnDeletecommand() 
{
	UpdateData( TRUE );

	int nString = m_cbCommand.FindStringExact( -1, m_sCommand );
	if( nString != CB_ERR )
		m_cbCommand.DeleteString( nString );

	updateRegistry();
}

void CCommandDialog::updateRegistry()
{
	int nCount = m_cbCommand.GetCount();
	CString sCommands;

	for( int nString = 0; nString < nCount; nString++ )
	{
		CString sItem;
		m_cbCommand.GetLBText( nString, sItem );
		sCommands += sItem + '\n';
	}

	regPutString( HKEY_CURRENT_USER, "Command History", "Commands", sCommands );
}
