/*  Wilbur - file indexing and search utility
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// ContentsSearchDialog.cpp : implementation file
//

#include "stdafx.h"
#include "wilbur.h"
#include "ContentsSearchDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CContentsSearchDialog dialog


CContentsSearchDialog::CContentsSearchDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CContentsSearchDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CContentsSearchDialog)
	m_bUseSoundex = FALSE;
	m_bReverse = FALSE;
	m_sStatus = _T("");
	m_sSearch = _T("");
	//}}AFX_DATA_INIT
}


void CContentsSearchDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContentsSearchDialog)
	DDX_Control(pDX, IDC_SEARCH_TEXT, m_cbSearch);
	DDX_Check(pDX, IDC_SOUNDEX, m_bUseSoundex);
	DDX_Check(pDX, IDC_REVERSE, m_bReverse);
	DDX_Text(pDX, IDC_SEARCH_STATUS, m_sStatus);
	DDX_CBString(pDX, IDC_SEARCH_TEXT, m_sSearch);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CContentsSearchDialog, CDialog)
	//{{AFX_MSG_MAP(CContentsSearchDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContentsSearchDialog message handlers

BOOL CContentsSearchDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ASSERT_VALID( m_pDocument );

	CList< CString, CString& > searchList;
	m_pDocument->readSearchHistory( searchList );

	for( POSITION pos = searchList.GetHeadPosition(); pos; )
	{
		CString sText = searchList.GetNext( pos );
		m_cbSearch.AddString( sText );
	}

	if( m_sSearch.GetLength() == 1 )
	{  // get rid of highlight for local search
		m_cbSearch.PostMessage( WM_CHAR, m_sSearch[0], 1 );
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
