;NSIS Script For Wilbur

; to build run
; \Program Files\NSIS\makensis.exe /Dlang=English wilbur.nsi
; from a cmd line
; be sure and set the output file name to the correct version before running

; determine language
!ifndef lang
!define lang "English"
!endif

LoadLanguageFile "${NSISDIR}\Contrib\Language files\${lang}.nlf"

!ifdef LANG_ENGLISH
!define helpdir "help"
!define langext ""
!include "install_en.txt"
!endif

!ifdef LANG_FRENCH
!define helpdir "aide"
!define langext "_fr"

!include "install_fr.txt"
!endif

!ifdef LANG_POLISH
!define helpdir "pomoc"
!define langext "_pl"

!include "install_pl.txt"
!endif

;Backgound Colors
BGGradient 0000FF 000000 FFFFFF

;Title Of Your Application
Name "Wilbur"
;Icon "C:\Documents and Settings\craig\My Documents\Projects\wilbur\res\wilbur.ico"
Icon "${NSISDIR}\contrib\Graphics\Icons\nsis1-install.ico"

;Do A CRC Check
CRCCheck On

;Output File Name
OutFile "wilbur22b13${langext}.exe"

;License Page Introduction
;LicenseText "You must agree to this license before installing."
LicenseText "${licensetext}" "${licensebutton}"

;License Data
LicenseData "C:\Documents and Settings\craig\My Documents\Projects\wilbur\license.txt"

;The text to prompt the user to enter a directory
;DirText "Please select the folder below"
DirText "${dirtext}"

;The Default Installation Directory
InstallDir "$PROGRAMFILES\Wilbur"

Section "Install"
  ;Install Files
  SetOutPath $INSTDIR
  SetCompress Auto
  SetOverwrite IfNewer
  File /oname=wilbur.exe "C:\extra\wilbur\Release\wilbur${langext}.exe"
  File "C:\extra\wilbur\Release\Wilbur.tlb"
  File /oname=WilburUtil.exe "C:\Documents and Settings\craig\My Documents\Projects\wilbur\WilburUtil\Release\WilburUtil${langext}.exe"
  File /oname=WilburNote.exe "C:\Documents and Settings\craig\My Documents\Projects\wilbur\WilburNote\Release\WilburNote${langext}.exe"
  File "C:\extra\wilbur\Release\zip32.dll"
  File "C:\extra\wilbur\Release\unzip32.dll"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\skip${langext}.txt"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\skip_en.txt"
  File /oname=skip.txt "C:\Documents and Settings\craig\My Documents\Projects\wilbur\skip${langext}.txt"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\includelist.txt"

  SetOutPath $INSTDIR\help

  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\about.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\about.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\appexit.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\autoquickview.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\build.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\build.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\cdscreen.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\cdwilbur.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\columns.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\command.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\commandline.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\contacting.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\contents.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\contentsearch.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\contentsearch.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\contexthelp.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\copy.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\copylist.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\curhelp.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\display.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\edit.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\edit.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\editcopy.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\editmenu.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\excludedialog.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\exec_command.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\exit.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\export.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\exportfilelist.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\file_list_columns.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\filecontents.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\filelist.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\filelist.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\filelistclip.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\filemenu.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\filenew.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\fileopen.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\fileprnt.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\filesave.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\findnext.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\findnext.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\findprev.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\findprevious.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\font.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\fonts.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\gettingstarted.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\google.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\gsbuilding.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\gshelp.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\gssearch.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\HelpIDs.txt"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\helpmenu.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\hidehtml.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\importwords.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\includebrowsedlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\includedialog.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\includedlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\includefiles.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\includepathdlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\index.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\index.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexbkgnd2.jpg"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexbkgnd.jpg"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexdialog.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexlanguage.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexlanguagedlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexmenu.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexoptions.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\indexoptionsdlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\international.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\launch.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\localsearch.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\menu_bar.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\misctips.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\mission.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\newindex.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\nextfile.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\notall.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oemtext.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleaddexclude.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleaddinclude.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleaddmessage.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleautomation.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olebuild.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olechangedrive.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleclearexcludes.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleclearincludes.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleclearmessages.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olecreate.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetaddedchar.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetaddedtrailing.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetcontents.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetcount.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetdostext.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetexclude.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetinclude.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetinternational.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetmessages.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetmodifieddate.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetnumberfiles.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetnumberhandling.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetnumberofbytes.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetnumberwords.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetpath.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetrackall.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetrank.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegettimecreated.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetzip.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olegetzipencryptflags.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleisnearok.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleopenindex.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olequit.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleremoveexclude.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleremoveinclude.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesaveindex.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesearchexample.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesearchexexample.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesearchfor.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesearchforex.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesearchresults.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesetaddedchar.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesetdostext.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesetinternational.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesetnumberhandling.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesettonext.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesettostart.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesettrackall.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesetzip.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\olesetzipencryptflags.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\oleupdate.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\openindex.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\outline.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\outline.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\overwrite.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\overwrite.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\preferences.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\preferences.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\previousfile.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\previousfiles.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\print.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\printfilelist.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\printsetup.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\printsetupdialog.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\quickfind.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\quickview.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\readdoc.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\readme.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\saveasdialog.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\saveindex.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\saveindexas.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\savemsword.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\scheduled.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\scheduledlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\scheduledlg.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\scheduleitem.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\screenshot.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\search.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\searchdialog.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\searchdlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\searchmenu.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\searchphrase.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\selectall.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\statusbar.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\stop.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\stop.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\tinylogo.jpg"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\toolbar.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\tooltray.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\update.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\update.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\viewmenu.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\whatsnew2.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\whatsnew21.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\whatsnew22.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\wilbur.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\wilburnote.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\wilburnote.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\wilburutil.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\windowpositioning.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\word_macro_example.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\wordcount.htm"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\wordcountdlg.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\zipencrypt.gif"
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\zipencrypt.htm"

!ifdef LANG_FRENCH
  File "C:\Documents and Settings\craig\My Documents\Projects\wilbur\website\${helpdir}\blocnote.gif"
!endif

  SetOutPath $INSTDIR

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Wilbur" "DisplayName" "Wilbur (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Wilbur" "UninstallString" "$INSTDIR\Uninst.exe"
WriteUninstaller "Uninst.exe"
SectionEnd

Section "Shortcuts"
  ;Add Shortcuts
  CreateDirectory "$SMPROGRAMS\Wilbur"
  CreateShortCut "$SMPROGRAMS\Wilbur\Wilbur.lnk" "$INSTDIR\wilbur.exe" "" "$INSTDIR\wilbur.exe" 0
  CreateShortCut "$SMPROGRAMS\Wilbur\WilburUtil.lnk" "$INSTDIR\WilburUtil.exe" "" "$INSTDIR\WilburUtil.exe" 0
  CreateShortCut "$SMPROGRAMS\Wilbur\WilburNote.lnk" "$INSTDIR\WilburNote.exe" "" "$INSTDIR\WilburNote.exe" 0
SectionEnd

;UninstallText "This will uninstall Wilbur from your system"
UninstallText "${uninstalltext}"
UninstallIcon "C:\Program Files\NSIS\contrib\Graphics\Icons\nsis1-uninstall.ico"

Section Uninstall
  ;Delete Files
  Delete "$INSTDIR\wilbur.exe"
  Delete "$INSTDIR\Wilbur.tlb"
  Delete "$INSTDIR\WilburUtil.exe"
  Delete "$INSTDIR\WilburNote.exe"
  Delete "$INSTDIR\skip.txt"
  Delete "$INSTDIR\skip_en.txt"
  Delete "$INSTDIR\skip${langext}.txt"
  Delete "$INSTDIR\includelist.txt"

  Delete "$INSTDIR\zip32.dll"
  Delete "$INSTDIR\unzip32.dll"

  Delete "$INSTDIR\help\about.gif"
  Delete "$INSTDIR\help\about.htm"
  Delete "$INSTDIR\help\appexit.gif"
  Delete "$INSTDIR\help\autoquickview.htm"
  Delete "$INSTDIR\help\build.gif"
  Delete "$INSTDIR\help\build.htm"
  Delete "$INSTDIR\help\cdscreen.gif"
  Delete "$INSTDIR\help\cdwilbur.htm"
  Delete "$INSTDIR\help\columns.htm"
  Delete "$INSTDIR\help\command.gif"
  Delete "$INSTDIR\help\commandline.htm"
  Delete "$INSTDIR\help\contacting.htm"
  Delete "$INSTDIR\help\contents.gif"
  Delete "$INSTDIR\help\contentsearch.gif"
  Delete "$INSTDIR\help\contentsearch.htm"
  Delete "$INSTDIR\help\contexthelp.htm"
  Delete "$INSTDIR\help\copy.htm"
  Delete "$INSTDIR\help\copylist.htm"
  Delete "$INSTDIR\help\curhelp.gif"
  Delete "$INSTDIR\help\display.htm"
  Delete "$INSTDIR\help\edit.gif"
  Delete "$INSTDIR\help\edit.htm"
  Delete "$INSTDIR\help\editcopy.gif"
  Delete "$INSTDIR\help\editmenu.htm"
  Delete "$INSTDIR\help\excludedialog.htm"
  Delete "$INSTDIR\help\exec_command.htm"
  Delete "$INSTDIR\help\exit.htm"
  Delete "$INSTDIR\help\export.htm"
  Delete "$INSTDIR\help\exportfilelist.htm"
  Delete "$INSTDIR\help\file_list_columns.htm"
  Delete "$INSTDIR\help\filecontents.htm"
  Delete "$INSTDIR\help\filelist.gif"
  Delete "$INSTDIR\help\filelist.htm"
  Delete "$INSTDIR\help\filelistclip.htm"
  Delete "$INSTDIR\help\filemenu.htm"
  Delete "$INSTDIR\help\filenew.gif"
  Delete "$INSTDIR\help\fileopen.gif"
  Delete "$INSTDIR\help\fileprnt.gif"
  Delete "$INSTDIR\help\filesave.gif"
  Delete "$INSTDIR\help\findnext.gif"
  Delete "$INSTDIR\help\findnext.htm"
  Delete "$INSTDIR\help\findprev.gif"
  Delete "$INSTDIR\help\findprevious.htm"
  Delete "$INSTDIR\help\font.gif"
  Delete "$INSTDIR\help\fonts.htm"
  Delete "$INSTDIR\help\gettingstarted.htm"
  Delete "$INSTDIR\help\google.gif"
  Delete "$INSTDIR\help\gsbuilding.htm"
  Delete "$INSTDIR\help\gshelp.htm"
  Delete "$INSTDIR\help\gssearch.htm"
  Delete "$INSTDIR\help\HelpIDs.txt"
  Delete "$INSTDIR\help\helpmenu.htm"
  Delete "$INSTDIR\help\hidehtml.htm"
  Delete "$INSTDIR\help\importwords.htm"
  Delete "$INSTDIR\help\includebrowsedlg.gif"
  Delete "$INSTDIR\help\includedialog.htm"
  Delete "$INSTDIR\help\includedlg.gif"
  Delete "$INSTDIR\help\includefiles.htm"
  Delete "$INSTDIR\help\includepathdlg.gif"
  Delete "$INSTDIR\help\index.gif"
  Delete "$INSTDIR\help\index.htm"
  Delete "$INSTDIR\help\indexbkgnd2.jpg"
  Delete "$INSTDIR\help\indexbkgnd.jpg"
  Delete "$INSTDIR\help\indexdialog.htm"
  Delete "$INSTDIR\help\indexlanguage.htm"
  Delete "$INSTDIR\help\indexlanguagedlg.gif"
  Delete "$INSTDIR\help\indexmenu.htm"
  Delete "$INSTDIR\help\indexoptions.htm"
  Delete "$INSTDIR\help\indexoptionsdlg.gif"
  Delete "$INSTDIR\help\international.htm"
  Delete "$INSTDIR\help\launch.htm"
  Delete "$INSTDIR\help\localsearch.htm"
  Delete "$INSTDIR\help\menu_bar.htm"
  Delete "$INSTDIR\help\misctips.htm"
  Delete "$INSTDIR\help\mission.htm"
  Delete "$INSTDIR\help\newindex.htm"
  Delete "$INSTDIR\help\nextfile.htm"
  Delete "$INSTDIR\help\notall.htm"
  Delete "$INSTDIR\help\oemtext.htm"
  Delete "$INSTDIR\help\oleaddexclude.htm"
  Delete "$INSTDIR\help\oleaddinclude.htm"
  Delete "$INSTDIR\help\oleaddmessage.htm"
  Delete "$INSTDIR\help\oleautomation.htm"
  Delete "$INSTDIR\help\olebuild.htm"
  Delete "$INSTDIR\help\olechangedrive.htm"
  Delete "$INSTDIR\help\oleclearexcludes.htm"
  Delete "$INSTDIR\help\oleclearincludes.htm"
  Delete "$INSTDIR\help\oleclearmessages.htm"
  Delete "$INSTDIR\help\olecreate.htm"
  Delete "$INSTDIR\help\olegetaddedchar.htm"
  Delete "$INSTDIR\help\olegetaddedtrailing.htm"
  Delete "$INSTDIR\help\olegetcontents.htm"
  Delete "$INSTDIR\help\olegetcount.htm"
  Delete "$INSTDIR\help\olegetdostext.htm"
  Delete "$INSTDIR\help\olegetexclude.htm"
  Delete "$INSTDIR\help\olegetinclude.htm"
  Delete "$INSTDIR\help\olegetinternational.htm"
  Delete "$INSTDIR\help\olegetmessages.htm"
  Delete "$INSTDIR\help\olegetmodifieddate.htm"
  Delete "$INSTDIR\help\olegetnumberfiles.htm"
  Delete "$INSTDIR\help\olegetnumberhandling.htm"
  Delete "$INSTDIR\help\olegetnumberofbytes.htm"
  Delete "$INSTDIR\help\olegetnumberwords.htm"
  Delete "$INSTDIR\help\olegetpath.htm"
  Delete "$INSTDIR\help\olegetrackall.htm"
  Delete "$INSTDIR\help\olegetrank.htm"
  Delete "$INSTDIR\help\olegettimecreated.htm"
  Delete "$INSTDIR\help\olegetzip.htm"
  Delete "$INSTDIR\help\olegetzipencryptflags.htm"
  Delete "$INSTDIR\help\oleisnearok.htm"
  Delete "$INSTDIR\help\oleopenindex.htm"
  Delete "$INSTDIR\help\olequit.htm"
  Delete "$INSTDIR\help\oleremoveexclude.htm"
  Delete "$INSTDIR\help\oleremoveinclude.htm"
  Delete "$INSTDIR\help\olesaveindex.htm"
  Delete "$INSTDIR\help\olesearchexample.htm"
  Delete "$INSTDIR\help\olesearchexexample.htm"
  Delete "$INSTDIR\help\olesearchfor.htm"
  Delete "$INSTDIR\help\olesearchforex.htm"
  Delete "$INSTDIR\help\olesearchresults.htm"
  Delete "$INSTDIR\help\olesetaddedchar.htm"
  Delete "$INSTDIR\help\olesetdostext.htm"
  Delete "$INSTDIR\help\olesetinternational.htm"
  Delete "$INSTDIR\help\olesetnumberhandling.htm"
  Delete "$INSTDIR\help\olesettonext.htm"
  Delete "$INSTDIR\help\olesettostart.htm"
  Delete "$INSTDIR\help\olesettrackall.htm"
  Delete "$INSTDIR\help\olesetzip.htm"
  Delete "$INSTDIR\help\olesetzipencryptflags.htm"
  Delete "$INSTDIR\help\oleupdate.htm"
  Delete "$INSTDIR\help\openindex.htm"
  Delete "$INSTDIR\help\outline.gif"
  Delete "$INSTDIR\help\outline.htm"
  Delete "$INSTDIR\help\overwrite.gif"
  Delete "$INSTDIR\help\overwrite.htm"
  Delete "$INSTDIR\help\preferences.gif"
  Delete "$INSTDIR\help\preferences.htm"
  Delete "$INSTDIR\help\previousfile.htm"
  Delete "$INSTDIR\help\previousfiles.htm"
  Delete "$INSTDIR\help\print.htm"
  Delete "$INSTDIR\help\printfilelist.htm"
  Delete "$INSTDIR\help\printsetup.htm"
  Delete "$INSTDIR\help\printsetupdialog.htm"
  Delete "$INSTDIR\help\quickfind.htm"
  Delete "$INSTDIR\help\quickview.htm"
  Delete "$INSTDIR\help\readdoc.htm"
  Delete "$INSTDIR\help\readme.htm"
  Delete "$INSTDIR\help\saveasdialog.htm"
  Delete "$INSTDIR\help\saveindex.htm"
  Delete "$INSTDIR\help\saveindexas.htm"
  Delete "$INSTDIR\help\savemsword.htm"
  Delete "$INSTDIR\help\scheduled.htm"
  Delete "$INSTDIR\help\scheduledlg.gif"
  Delete "$INSTDIR\help\scheduledlg.htm"
  Delete "$INSTDIR\help\scheduleitem.gif"
  Delete "$INSTDIR\help\screenshot.gif"
  Delete "$INSTDIR\help\search.gif"
  Delete "$INSTDIR\help\searchdialog.htm"
  Delete "$INSTDIR\help\searchdlg.gif"
  Delete "$INSTDIR\help\searchmenu.htm"
  Delete "$INSTDIR\help\searchphrase.htm"
  Delete "$INSTDIR\help\selectall.htm"
  Delete "$INSTDIR\help\statusbar.htm"
  Delete "$INSTDIR\help\stop.gif"
  Delete "$INSTDIR\help\stop.htm"
  Delete "$INSTDIR\help\tinylogo.jpg"
  Delete "$INSTDIR\help\toolbar.htm"
  Delete "$INSTDIR\help\tooltray.gif"
  Delete "$INSTDIR\help\update.gif"
  Delete "$INSTDIR\help\update.htm"
  Delete "$INSTDIR\help\viewmenu.htm"
  Delete "$INSTDIR\help\whatsnew2.htm"
  Delete "$INSTDIR\help\whatsnew21.htm"
  Delete "$INSTDIR\help\whatsnew22.htm"
  Delete "$INSTDIR\help\wilbur.gif"
  Delete "$INSTDIR\help\wilburnote.gif"
  Delete "$INSTDIR\help\wilburnote.htm"
  Delete "$INSTDIR\help\wilburutil.htm"
  Delete "$INSTDIR\help\windowpositioning.htm"
  Delete "$INSTDIR\help\word_macro_example.htm"
  Delete "$INSTDIR\help\wordcount.htm"
  Delete "$INSTDIR\help\wordcountdlg.gif"
  Delete "$INSTDIR\help\zipencrypt.gif"
  Delete "$INSTDIR\help\zipencrypt.htm"

!ifdef LANG_FRENCH
  Delete "$INSTDIR\help\blocnote.gif"
!endif
  
  ;Delete Start Menu Shortcuts
  Delete "$SMPROGRAMS\Wilbur\*.*"
  RmDir "$SMPROGRAMS\Wilbur"

  ; Additional Files To Remove During Uninstall
  DeleteRegKey HKEY_CURRENT_USER "SOFTWARE\Redtree"
  DeleteRegKey HKEY_CURRENT_USER "SOFTWARE\RedTree"

  ;Delete Uninstaller And Unistall Registry Entries
  Delete "$INSTDIR\Uninst.exe"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Wilbur"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Wilbur"
  RMDir "$INSTDIR\help"
  RMDir "$INSTDIR"
SectionEnd
