/*  Wilbur - file indexing and search utility
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
#if !defined(AFX_SEARCHCRITERIA_H__8C5A2193_ED0C_11D1_B2D4_006008A8E2D0__INCLUDED_)
#define AFX_SEARCHCRITERIA_H__8C5A2193_ED0C_11D1_B2D4_006008A8E2D0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SearchCriteria.h : header file
//



/////////////////////////////////////////////////////////////////////////////
// CSearchCriteria command target

class CSearchCriteria : public CCmdTarget
{
	DECLARE_SERIAL(CSearchCriteria)

	protected:
		CSearchCriteria();           // protected constructor used by dynamic creation

	// Attributes
	public:
		CSearchCriteria( bool bAutomated );  // so it can be created locally

		void clear();  // sets to default values

		COleDateTime getBeforeTime() { return m_onOrBefore; }
		COleDateTime getAfterTime()  { return m_onOrAfter; }
		bool setBeforeTime( CString sBefore );
		bool setAfterTime( CString sAfter );

		long getMinSize() { return m_minSize; }
		long getMaxSize() { return m_maxSize; }
		void setMinSize( long nNewValue ) { m_minSize = nNewValue; }
		void setMaxSize( long nNewValue ) { m_maxSize = nNewValue; }
		
		CString getFileName()     { return m_fileName; }
		void setFileName( CString sNewValue )		{ m_fileName = sNewValue; }

		CString getFolderName()   { return m_folderName; }
		void setFolderName( CString sNewValue );

		DWORD getAttributes()   { return m_attributes; }
		void setAttributes( DWORD dwNewValue )		{ m_attributes = dwNewValue; }
		void setAttributes( CString sNewValue );

		bool getReverse() { return ( m_reverse == TRUE ); }
		void setReverse( bool bNewValue ) { m_reverse = bNewValue; }

		bool getSoundex() { return ( m_soundex == TRUE ); }
		void setSoundex( bool bNewValue ) { m_soundex = bNewValue; }

		void storeInRegistry();
		void recallFromRegistry();

	// Operations
	public:
		virtual ~CSearchCriteria();

	// Overrides
		// ClassWizard generated virtual function overrides
		//{{AFX_VIRTUAL(CSearchCriteria)
		public:
		virtual void OnFinalRelease();
		//}}AFX_VIRTUAL

	// Implementation
	protected:
		bool m_bAutomated;
	
		// Generated message map functions
		//{{AFX_MSG(CSearchCriteria)
			// NOTE - the ClassWizard will add and remove member functions here.
		//}}AFX_MSG

		DECLARE_MESSAGE_MAP()
		DECLARE_OLECREATE(CSearchCriteria)

		// Generated OLE dispatch map functions
		//{{AFX_DISPATCH(CSearchCriteria)
	CString m_fileName;
	afx_msg void OnFileNameChanged();
	DATE m_onOrBefore;
	afx_msg void OnOnOrBeforeChanged();
	DATE m_onOrAfter;
	afx_msg void OnOnOrAfterChanged();
	CString m_folderName;
	afx_msg void OnFolderNameChanged();
	long m_minSize;
	afx_msg void OnMinSizeChanged();
	long m_maxSize;
	afx_msg void OnMaxSizeChanged();
	BOOL m_reverse;
	afx_msg void OnReverseChanged();
	BOOL m_soundex;
	afx_msg void OnSoundexChanged();
	long m_attributes;
	afx_msg void OnAttributesChanged();
	//}}AFX_DISPATCH
		DECLARE_DISPATCH_MAP()
		DECLARE_INTERFACE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEARCHCRITERIA_H__8C5A2193_ED0C_11D1_B2D4_006008A8E2D0__INCLUDED_)
