/*  Wilbur - file indexing and search utility - WilburNote - quick note taker
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// WilburNote.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "WilburNote.h"
#include "WilburNoteDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString regGetString( HKEY hBaseKey, CString sSubKey, CString sVarName, CString sDefault )
{ 
	HKEY hKeySoftware;

	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		sSubKey = "RedTree\\Wilbur\\" + sSubKey;

		lResult = RegOpenKeyEx( hKeySoftware, sSubKey,
		                        0, KEY_READ, &hSubKey );

		if( lResult == ERROR_SUCCESS )
		{
			unsigned long nSize;

			lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
			                           NULL, &nSize );

			if( lResult == ERROR_SUCCESS )
			{
				CString sVar;
				lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
										   (LPBYTE) sVar.GetBuffer( nSize ), &nSize );
				sVar.ReleaseBuffer();

				if( lResult == ERROR_SUCCESS )
					sDefault = sVar;
			}

			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return sDefault;
}

/////////////////////////////////////////////////////////////////////////////
// CWilburNoteApp

BEGIN_MESSAGE_MAP(CWilburNoteApp, CWinApp)
	//{{AFX_MSG_MAP(CWilburNoteApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWilburNoteApp construction

CWilburNoteApp::CWilburNoteApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWilburNoteApp object

CWilburNoteApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWilburNoteApp initialization

BOOL CWilburNoteApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CWilburNoteDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK && !dlg.m_sNote.IsEmpty() )
	{
		CString sPath = regGetString( HKEY_CURRENT_USER, "WilburNote", "Folder", "." );
		CString sDate = CTime::GetCurrentTime().Format("%Y%m%d" );

		sPath += "\\WN";
		sPath += sDate + "_";

		CString sFile;
		sFile.Format( "%s*.txt", sPath );

		WIN32_FIND_DATA fileData;
		HANDLE hFind = FindFirstFile( sFile, &fileData );
		int nMax = 1;
		if( hFind != INVALID_HANDLE_VALUE )
		{
			do
			{
				nMax++;
			}  while ( FindNextFile( hFind, &fileData ) );

			FindClose( hFind );
		}

		sFile.Format( "%s%d.txt", sPath, nMax );
		// could still be conflict, so...
		while( ( hFind = FindFirstFile( sFile, &fileData ) ) != INVALID_HANDLE_VALUE )
		{
			FindClose( hFind );
			sFile.Format( "%s%d.txt", sPath, ++nMax );
		}

		try
		{
			CStdioFile output( sFile, CFile::modeCreate | CFile::modeWrite );
			output.WriteString( dlg.m_sNote );
		}
		catch( ... )
		{
			DWORD nErr = GetLastError(); 

			char* pszMessage; 
			FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, 
						   NULL, nErr, 0, (char*) &pszMessage, 10, NULL ); 

			CString sMsg = "Arrrgh - I can't save the file - this should never happen- ARRRGGGHH!!\n"; 
			sMsg += pszMessage; 

			AfxMessageBox(  sMsg ); 
			LocalFree( pszMessage ); 
		}
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
