/*  Wilbur - file indexing and search utility
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// WilburResults.h : header file
//

#ifndef __WILBURRESULTS_H__
#define __WILBURRESULTS_H__ 1

/////////////////////////////////////////////////////////////////////////////
// CWilburResults command target

// OLE automation object for returning search reults to a caller

#ifndef __CONTENTS_H__
#include "contents.h"
#endif

#ifndef __FILEINDX_H__
#include "fileindx.h"
#endif

class CWilburResults : public CCmdTarget
{
	DECLARE_DYNCREATE(CWilburResults)

	CWilburResults();           // protected constructor used by dynamic creation

	// Attributes
	public:

	// Operations
	public:
		void setSearchResults( CSearchResults* pResults, CWilburDoc* pDoc );

	// Overrides
		// ClassWizard generated virtual function overrides
		//{{AFX_VIRTUAL(CWilburResults)
		public:
		virtual void OnFinalRelease();
		//}}AFX_VIRTUAL

	// Implementation
	protected:
		virtual ~CWilburResults();

		// Generated message map functions
		//{{AFX_MSG(CWilburResults)
			// NOTE - the ClassWizard will add and remove member functions here.
		//}}AFX_MSG

		DECLARE_MESSAGE_MAP()
		// Generated OLE dispatch map functions
		//{{AFX_DISPATCH(CWilburResults)
	afx_msg BOOL setToStart();
	afx_msg BOOL setToNext();
	afx_msg BSTR getPath();
	afx_msg DATE getModifiedDate();
	afx_msg long getRank();
	afx_msg BOOL isNearOK();
	afx_msg long getCount();
	afx_msg BSTR getContents(BOOL bOutline, long nMaxChars);
	//}}AFX_DISPATCH
		DECLARE_DISPATCH_MAP()
		DECLARE_INTERFACE_MAP()


	private:
		CSearchResults* m_pResults;
		CWilburDoc*     m_pDoc;
		POSITION        m_position;
		CFileInfo*      m_pLastFile;
		CFileResult     m_lastResult;
		CAutoContents*  m_pContents;
		CString         m_sSearchText;
		bool			m_bUseSoundex;
};

/////////////////////////////////////////////////////////////////////////////
#endif
