/*  Wilbur - file indexing and search utility - WilburUtil launcher and scheduler
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// ScheduleDialog.cpp : implementation file
//

#include "stdafx.h"
#include "wilburutil.h"
#include "ScheduleDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScheduleDialog dialog


CScheduleDialog::CScheduleDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CScheduleDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScheduleDialog)
	m_sIndex = _T("");
	m_sStartTime = _T("");
	m_bUpdate = FALSE;
	m_nUnit = -1;
	m_nInterval = 0;
	//}}AFX_DATA_INIT
}


void CScheduleDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScheduleDialog)
	DDX_Text(pDX, IDC_INDEX, m_sIndex);
	DDX_Text(pDX, IDC_START_TIME, m_sStartTime);
	DDX_Check(pDX, IDC_UPDATE, m_bUpdate);
	DDX_Radio(pDX, IDC_UNIT_DAY, m_nUnit);
	DDX_Text(pDX, IDC_INTERVAL, m_nInterval);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScheduleDialog, CDialog)
	//{{AFX_MSG_MAP(CScheduleDialog)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScheduleDialog message handlers

void CScheduleDialog::OnBrowse() 
{
	// start by changing to default index directory
	CString sDefault = regGetString( HKEY_CURRENT_USER, "Settings", "Path", "c:\\Program Files\\Redtree\\Wilbur\\" );
	sDefault += "indexes";
	CString sIndexPath = regGetString( HKEY_CURRENT_USER, "Options", "IndexPath", sDefault );

	char currentDir[ MAX_PATH ]; 
	GetCurrentDirectory( MAX_PATH, currentDir ); 
	
	SetCurrentDirectory( sIndexPath );

	static char BASED_CODE szFilter[] = "Wilbur Indexes (*.wil)|*.wil|All Files (*.*)|*.*||";

	CFileDialog dlg( TRUE, "wil", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter );
	if( dlg.DoModal() == IDOK )
	{
		m_sIndex = dlg.GetPathName();
		UpdateData( FALSE );
	}

	SetCurrentDirectory( currentDir ); 
}
