/*  Wilbur - file indexing and search utility - WilburUtil launcher and scheduler
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// WilburUtil.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "WilburUtil.h"
#include "WilburUtilDlg.h"

#if !defined(__ICONFRAME_H__)
#include "IconFrame.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWilburUtilApp

BEGIN_MESSAGE_MAP(CWilburUtilApp, CWinApp)
	//{{AFX_MSG_MAP(CWilburUtilApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWilburUtilApp construction

CWilburUtilApp::CWilburUtilApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWilburUtilApp object

CWilburUtilApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWilburUtilApp initialization

BOOL CWilburUtilApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif


	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("RedTree"));

	LoadStdProfileSettings();  // Load standard INI file options (including	MRU)

	// The one and only window has been initialized, so show and update it.

	m_pMainWnd = new CIconFrame();
	m_pMainWnd->ShowWindow(SW_HIDE);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

CString regGetString( HKEY hBaseKey, CString sSubKey, CString sVarName, CString sDefault )
{ 
	HKEY hKeySoftware;

	long lResult = RegOpenKeyEx( hBaseKey, "Software", 0, KEY_READ, &hKeySoftware );
	if( lResult == ERROR_SUCCESS )
	{
		HKEY hSubKey;
		sSubKey = "RedTree\\Wilbur\\" + sSubKey;

		lResult = RegOpenKeyEx( hKeySoftware, sSubKey,
		                        0, KEY_READ, &hSubKey );

		if( lResult == ERROR_SUCCESS )
		{
			unsigned long nSize;

			lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
			                           NULL, &nSize );

			if( lResult == ERROR_SUCCESS )
			{
				CString sVar;
				lResult = RegQueryValueEx( hSubKey, sVarName, NULL, NULL,
										   (LPBYTE) sVar.GetBuffer( nSize ), &nSize );
				sVar.ReleaseBuffer();

				if( lResult == ERROR_SUCCESS )
					sDefault = sVar;
			}

			RegCloseKey( hSubKey );
		}

		RegCloseKey( hKeySoftware );
	}

	return sDefault;
}

