/*  Wilbur - file indexing and search utility - WilburUtil launcher and scheduler
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// Icon Frame.h : declaration file
//
// Icon Frame core design by Andy Stacy 1997.
// This Code may be used freely and modified as required providing a reference to the author is left
// in the file header.
//

#if !defined(__ICONFRAME_H__)
#define __ICONFRAME_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Icon Frame.h : header file
//
#define ICON_CALLBACK  WM_USER + 100
#define CLOSE_MESSAGE  WM_USER + 101
#define LAUNCH_WILBUR WM_USER + 102
#define LAUNCH_NOTE WM_USER + 103
#define SCHEDULE_DIALOG WM_USER + 104
#define LAUNCH_WILBUR2 WM_USER + 105

#if !defined( __SCHEDULE_H__)
#include "schedule.h"
#endif

/////////////////////////////////////////////////////////////////////////////

// CIconFrame frame

class CIconFrame : public CFrameWnd
{
	DECLARE_DYNCREATE(CIconFrame)
	public:
		CIconFrame();           // protected constructor used by dynamic creation

	// Attributes
	public:
		void IconCallback( WPARAM wParam, LPARAM lParam);
		HICON m_okicon;
		void IconMessage(DWORD dwMessage);

	// Operations
	public:
		CMenu *m_pIconPopup;

		// Overrides
		// ClassWizard generated virtual function overrides
		//{{AFX_VIRTUAL(CIconFrame)
		public:
		virtual BOOL DestroyWindow();
		protected:
		virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
		virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext *pContext);
		//}}AFX_VIRTUAL

	// Implementation
	protected:
		virtual ~CIconFrame();

		void launch( CString sProg );
		void setUpTimer();

		CScheduleList m_scheduleList;
		UINT          m_idTimer;  // TImer ID

		// Generated message map functions
		//{{AFX_MSG(CIconFrame)
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
		afx_msg void IconMenuClose( void );
		afx_msg void IconClosePopup( void );
		afx_msg void launchWilbur( void );
		afx_msg void launch2ndWilbur( void );
		afx_msg void launchNote( void );
		afx_msg void scheduleDialog( void );
		// Add other menu command handlers after here ...
		DECLARE_MESSAGE_MAP()
	};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.
//

#endif // __ICONFRAME_H__
