/*  Wilbur - file indexing and search utility - WilburUtil launcher and scheduler
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
#if !defined( __SCHEDULE_H__)
#define __SCHEDULE_H__

#ifndef __AFXTEMPL_H__
#include "afxtempl.h"
#endif

#ifndef __AFXDISP_H__ 
#include <afxdisp.h>
#endif

class CSchedule : public CObject
{
	DECLARE_SERIAL( CSchedule );

	public:
		enum IntervalType{ UNDEFINED, DAY, HOUR, MINUTE };
		
		CSchedule();
		CSchedule( CString sIndexPath,
			       COleDateTime startTime,
				   int nInterval,
				   IntervalType type,
				   bool bUpdate = false,
				   bool bSecondInstance = false );
		
		
		virtual void Serialize( CArchive& archive );
		const CSchedule& operator=( const CSchedule& source );

		COleDateTime getNextStart();
		COleDateTime getStartTime() { return m_startTime; }
		CString getIndexPath()      { return m_sIndexPath; }
		int getInterval()           { return m_nInterval; }
		IntervalType getUnit()      { return m_intervalType; }
		bool isUpdate()             { return m_bUpdate; }
		bool isSecondInstance()     { return m_bSecondInstance; }

	private:
		COleDateTime	m_startTime;
		CString			m_sIndexPath;
		int				m_nInterval;
		IntervalType	m_intervalType;
		bool			m_bUpdate;
		bool			m_bSecondInstance;
};

typedef CList< CSchedule, CSchedule& > CScheduleList;

#endif
