/*  Wilbur - file indexing and search utility
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// WordCountDialog.cpp : implementation file
//

#include "stdafx.h"
#include "wilbur.h"
#include "WordCountDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWordCountDialog dialog


CWordCountDialog::CWordCountDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CWordCountDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWordCountDialog)
	m_sResultFile = _T("");
	m_dPercent = 0.0;
	//}}AFX_DATA_INIT
}


void CWordCountDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWordCountDialog)
	DDX_Text(pDX, IDC_RESULTS_FILE, m_sResultFile);
	DDX_Text(pDX, IDC_WORD_PERCENT, m_dPercent);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWordCountDialog, CDialog)
	//{{AFX_MSG_MAP(CWordCountDialog)
	ON_BN_CLICKED(IDC_BROWSE_RESULTS, OnBrowseResults)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWordCountDialog message handlers

BOOL CWordCountDialog::OnInitDialog() 
{
	m_dPercent = 20.0;

	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWordCountDialog::OnBrowseResults() 
{
	CFileDialog dlg( FALSE, "txt", "*.txt", OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_OVERWRITEPROMPT  ); 

	if( dlg.DoModal() == IDOK )
	{ 
		UpdateData( TRUE );
		m_sResultFile = dlg.GetPathName(); 

		UpdateData( FALSE );
	}
}
