/*  Wilbur - file indexing and search utility
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// dialogs.h : header file
//

#ifndef __DIALOGS_H__
#define _DIALOGS_H__ 1

#ifndef __WILBUDOC_H__
#include "wilbudoc.h"
#endif

#ifndef __FILEINDX_H__
#include "fileindx.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CSearchDialog dialog

class CSearchDialog : public CDialog
{
	// Construction
	public:
		CSearchDialog(CWnd* pParent = NULL);   // standard constructor
		CWilburDoc*			m_pDocument;
		CSearchCriteria*	m_pCriteria;

	// Dialog Data
		//{{AFX_DATA(CSearchDialog)
	enum { IDD = IDD_SEARCH };
	CComboBox	m_cbIndex;
	CComboBox	m_cbTemplate;
		CComboBox	m_cbSearch;
		CString	m_sSearch;
		BOOL	m_bUseSoundex;
	BOOL	m_bReverse;
	CString	m_sStatus;
	CString	m_sAttributes;
	CString	m_sTemplate;
	CString	m_sFolder;
	CString	m_sBefore;
	CString	m_sAfter;
	CString	m_sMaxSize;
	CString	m_sMinSize;
	CString	m_sFileMask;
	CString	m_sIndex;
	//}}AFX_DATA

	// Overrides
		virtual BOOL OnInitDialog();

		// ClassWizard generated virtual function overrides
		//{{AFX_VIRTUAL(CSearchDialog)
		protected:
		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		//}}AFX_VIRTUAL

	// Implementation
	protected:
		void setFields();
		void loadTemplate( CString sTemplate );

		// Generated message map functions
		//{{AFX_MSG(CSearchDialog)
	virtual void OnOK();
	afx_msg void OnClear();
	afx_msg void OnSaveTemplate();
	afx_msg void OnSelchangeTemplate();
	afx_msg void OnGetTemplate();
	afx_msg void OnEditchangeTemplate();
	afx_msg void OnKillfocusTemplate();
	afx_msg void OnDeleteTemplate();
	//}}AFX_MSG
		DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CIncludeDialog dialog

class CIncludeDialog : public CDialog
{
// Construction
public:
	CIncludeDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CIncludeDialog)
	enum { IDD = IDD_INCLUDE };
	CString	m_sInclude;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIncludeDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CIncludeDialog)
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CExcludeDialog dialog

class CExcludeDialog : public CDialog
{
// Construction
public:
	CExcludeDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CExcludeDialog)
	enum { IDD = IDD_EXCLUDE };
	CString	m_sExclude;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExcludeDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CExcludeDialog)
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
#endif
/////////////////////////////////////////////////////////////////////////////
// CPreferencesDialog dialog

class CPreferencesDialog : public CDialog
{
// Construction
public:
	CPreferencesDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CPreferencesDialog)
	enum { IDD = IDD_PREFERENCES };
	CButton	m_horizontal;
	CButton	m_vertical;
	CString	m_sEditor;
	CString	m_sZipPath;
	int		m_nNear;
	int		m_nTabSize;
	int		m_nWordWrap;
	CString	m_sIndexPath;
	BOOL	m_bOutline;
	UINT	m_nFileHistory;
	int		m_nMaxBuffer;
	BOOL	m_bCachePDF;
	CString	m_spdftotextArgs;
	int		m_nHorizontal;
	int		m_nVertical;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPreferencesDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
	int m_nOrientation;

protected:

	// Generated message map functions
	//{{AFX_MSG(CPreferencesDialog)
	afx_msg void OnBrowse();
	afx_msg void OnVertical();
	afx_msg void OnHorizontal();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CIndexOptionsPage dialog

class CIndexOptionsPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CIndexOptionsPage)

	// Construction
	public:
		CIndexOptionsPage();
		~CIndexOptionsPage();

	// Dialog Data
		//{{AFX_DATA(CIndexOptionsPage)
	enum { IDD = IDD_INDEXOPTIONS };
		CButton	m_ckbZip;
		CComboBox	m_NumberHandler;
		BOOL	m_bUseZip;
	CString	m_sAddedChars;
	CString	m_sAddedTrailing;
	int		m_nMaxWordLength;
	int		m_nMinWordLength;
	BOOL	m_bUseRanking;
	BOOL	m_bTrackAll;
	//}}AFX_DATA

		CFileIndex* m_pIndex;
		int m_nNumber;


	// Overrides
		// ClassWizard generate virtual function overrides
		//{{AFX_VIRTUAL(CIndexOptionsPage)
		protected:
		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		//}}AFX_VIRTUAL

	// Implementation
	protected:
		// Generated message map functions
		//{{AFX_MSG(CIndexOptionsPage)
		afx_msg void OnSelendokNumbers();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
		DECLARE_MESSAGE_MAP()

};
/////////////////////////////////////////////////////////////////////////////
// CIndexFilesPage dialog

class CIndexFilesPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CIndexFilesPage)

		// Construction
	public:
		CIndexFilesPage();
		CIndexFilesPage( UINT nIDCaption );
		~CIndexFilesPage();

	// Dialog Data
		//{{AFX_DATA(CIndexFilesPage)
		enum { IDD = IDD_INDEXFILES };
		CListBox	m_lbInclude;
		//}}AFX_DATA

		CFileIndex* m_pIndex;
		CWilburDoc* m_pDocument;

	// Overrides
		// ClassWizard generated virtual function overrides
		//{{AFX_VIRTUAL(CIndexFilesPage)
		protected:
		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		//}}AFX_VIRTUAL

	// Implementation
	protected:
		UINT m_nIDCaption;
		void fillLists();
		void nothingSelected();

		// Generated message map functions
		//{{AFX_MSG(CIndexFilesPage)
		afx_msg void OnAddInclude();
		afx_msg void OnClearIncludes();
		afx_msg void OnDeleteInclude();
		afx_msg void OnEditInclude();
	virtual BOOL OnInitDialog();
	afx_msg void OnCopyIncludes();
	afx_msg void OnPasteIncludes();
	//}}AFX_MSG
		DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CIndexLanguagePage dialog

class CIndexLanguagePage : public CPropertyPage
{
	DECLARE_DYNCREATE(CIndexLanguagePage)

// Construction
public:
	CIndexLanguagePage();   // standard constructor

// Dialog Data
	//{{AFX_DATA(CIndexLanguagePage)
	enum { IDD = IDD_INDEX_LANGUAGE };
	BOOL	m_bDanish;
	BOOL	m_bFinnish;
	BOOL	m_bFrench;
	BOOL	m_bGerman;
	BOOL	m_bInternationalChar;
	BOOL	m_bSpanish;
	BOOL	m_bSwedish;
	CString	m_sSkipFile;
	BOOL	m_bOEMChar;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIndexLanguagePage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CIndexLanguagePage)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CIndexEncrypt dialog

class CIndexEncrypt : public CPropertyPage
{
	DECLARE_DYNCREATE(CIndexEncrypt)

// Construction
public:
	CIndexEncrypt();
	~CIndexEncrypt();

// Dialog Data
	//{{AFX_DATA(CIndexEncrypt)
	enum { IDD = IDD_INDEXENCRYPT };
	BOOL	m_bEncryptNew;
	CString	m_sPassword;
	BOOL	m_bRestrictCopies;
	BOOL	m_bStorePassword;
	CString	m_sPasswordCheck;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CIndexEncrypt)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CIndexEncrypt)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
/////////////////////////////////////////////////////////////////////////////
// CConfirmPassword dialog

class CConfirmPassword : public CDialog
{
// Construction
public:
	CConfirmPassword(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CConfirmPassword)
	enum { IDD = IDD_CHECKPASSWORD };
	CString	m_sPassword;
	CString	m_sMessage;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CConfirmPassword)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CConfirmPassword)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
