/*  Wilbur - file indexing and search utility
 *  Copyright (C) 1995-1999  Craig Morris and RedTree Development Inc.
 *        craig@redtree.com - <http://wilbur.redtree.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  or at http://www.fsf.org
*/
// wilbudoc.cpp : implementation of the CWilburDoc class
//

#include "stdafx.h"
#include <direct.h>

#ifndef __WILBUR_H__
#include "wilbur.h"
#endif

#ifndef __MAINFRM_H__
#include "mainfrm.h"
#endif

#ifndef __WILBUDOC_H__
#include "wilbudoc.h"
#endif

#ifndef __FILELIST_H__
#include "FileListView.h"
#endif

#ifndef __CONTENTS_H__
#include "contents.h"
#endif

#ifndef __DIALOGS_H__
#include "dialogs.h"
#endif

#ifndef __WILBURRESULTS_H__
#include "wilburresults.h"
#endif

#if !defined(AFX_SEARCHCRITERIA_H__8C5A2193_ED0C_11D1_B2D4_006008A8E2D0__INCLUDED_)
#include "searchcriteria.h"
#endif

#if !defined(__WORDCOUNTDIALOG_H__)
#include "wordcountdialog.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWilburDoc

IMPLEMENT_DYNCREATE(CWilburDoc, CDocument)

BEGIN_MESSAGE_MAP(CWilburDoc, CDocument)
	//{{AFX_MSG_MAP(CWilburDoc)
	ON_COMMAND(ID_INDEX_BUILD, OnIndexBuild)
	ON_COMMAND(ID_INDEX_SEARCH, OnIndexSearch)
	ON_COMMAND(ID_INDEX_FINDNEXT, OnIndexFindnext)
	ON_COMMAND(ID_EDIT_INDEX, OnEditIndex)
	ON_COMMAND(ID_FILE_EDIT, OnFileEdit)
	ON_UPDATE_COMMAND_UI(ID_FILE_EDIT, OnUpdateFileEdit)
	ON_COMMAND(ID_FILE_LAUNCH, OnFileLaunch)
	ON_UPDATE_COMMAND_UI(ID_FILE_LAUNCH, OnUpdateFileLaunch)
	ON_COMMAND(ID_VIEW_FONT, OnViewFont)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_EDIT_INDEX, OnUpdateEditIndex)
	ON_COMMAND(ID_INDEX_UPDATE, OnIndexUpdate)
	ON_UPDATE_COMMAND_UI(ID_INDEX_UPDATE, OnUpdateIndexUpdate)
	ON_UPDATE_COMMAND_UI(ID_INDEX_BUILD, OnUpdateIndexBuild)
	ON_UPDATE_COMMAND_UI(ID_INDEX_SEARCH, OnUpdateIndexSearch)
	ON_UPDATE_COMMAND_UI(ID_INDEX_FINDNEXT, OnUpdateIndexFindnext)
	ON_COMMAND(ID_SEARCH_QUICKFIND, OnSearchQuickfind)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_QUICKFIND, OnUpdateSearchQuickfind)
	ON_COMMAND(ID_VIEW_INTERNATIONAL, OnViewInternational)
	ON_UPDATE_COMMAND_UI(ID_VIEW_INTERNATIONAL, OnUpdateViewInternational)
	ON_COMMAND(ID_VIEW_NEXT, OnViewNext)
	ON_UPDATE_COMMAND_UI(ID_VIEW_NEXT, OnUpdateViewNext)
	ON_COMMAND(ID_VIEW_PREV, OnViewPrev)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PREV, OnUpdateViewPrev)
	ON_COMMAND(ID_SEARCH_FINDPREVIOUS, OnSearchFindprevious)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_FINDPREVIOUS, OnUpdateSearchFindprevious)
	ON_COMMAND(ID_VIEW_QUICK, OnViewQuick)
	ON_UPDATE_COMMAND_UI(ID_VIEW_QUICK, OnUpdateViewQuick)
	ON_COMMAND(ID_VIEW_AUTOQUICK, OnViewAutoquick)
	ON_UPDATE_COMMAND_UI(ID_VIEW_AUTOQUICK, OnUpdateViewAutoquick)
	ON_COMMAND(ID_VIEW_OEMTEXT, OnViewOemtext)
	ON_UPDATE_COMMAND_UI(ID_VIEW_OEMTEXT, OnUpdateViewOemtext)
	ON_COMMAND(ID_VIEW_OUTLINE, OnViewOutline)
	ON_UPDATE_COMMAND_UI(ID_VIEW_OUTLINE, OnUpdateViewOutline)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_VIEWHIDEHTML, OnViewhidehtml)
	ON_UPDATE_COMMAND_UI(ID_VIEWHIDEHTML, OnUpdateViewhidehtml)
	ON_COMMAND(ID_WORD_COUNT, OnWordCount)
	ON_COMMAND(ID_IMPORT_SKIP, OnImportSkip)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CWilburDoc, CDocument)
	//{{AFX_DISPATCH_MAP(CWilburDoc)
	DISP_FUNCTION(CWilburDoc, "Quit", oleQuit, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "OpenIndex", oleOpenIndex, VT_BOOL, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "SearchFor", oleSearchFor, VT_DISPATCH, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "ShowWindow", oleShowWindow, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "SaveIndex", oleSaveIndex, VT_BOOL, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "Build", oleBuild, VT_BOOL, VTS_I4)
	DISP_FUNCTION(CWilburDoc, "Update", oleUpdate, VT_BOOL, VTS_I4)
	DISP_FUNCTION(CWilburDoc, "AddInclude", oleAddInclude, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "AddExclude", oleAddExclude, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "RemoveInclude", oleRemoveInclude, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "RemoveExclude", oleRemoveExclude, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "ClearIncludes", ClearIncludes, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "ClearExcludes", oleClearExcludes, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetInclude", oleGetInclude, VT_BSTR, VTS_I4)
	DISP_FUNCTION(CWilburDoc, "GetExclude", oleGetExclude, VT_BSTR, VTS_I4)
	DISP_FUNCTION(CWilburDoc, "SetNumberHandling", oleSetNumberHandling, VT_EMPTY, VTS_I2)
	DISP_FUNCTION(CWilburDoc, "GetNumberHandling", oleGetNumberHandling, VT_I2, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetInternational", oleGetInternational, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "SetInternational", oleSetInternational, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CWilburDoc, "SetDOSText", oleSetDOSText, VT_EMPTY, VTS_BOOL)
	DISP_FUNCTION(CWilburDoc, "GetDOSText", oleGetDOSText, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "SetAddedCharacters", oleSetAddedCharacters, VT_EMPTY, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "GetAddedCharacters", oleGetAddedCharacters, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetAddedTrailing", oleGetAddedTrailing, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetZip", oleGetZip, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "SetZip", oleSetZip, VT_EMPTY, VTS_BOOL)
	DISP_FUNCTION(CWilburDoc, "GetNumberOfFiles", oleGetNumberOfFiles, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetNumberOfWords", oleGetNumberOfWords, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetNumberOfBytes", oleGetNumberOfBytes, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetTimeCreated", oleGetTimeCreated, VT_DATE, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetMessages", oleGetMessages, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "AddMessage", oleAddMessage, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CWilburDoc, "ClearMessages", oleClearMessages, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "GetTrackAll", oleGetTrackAll, VT_BOOL, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "SetTrackAll", oleSetTrackAll, VT_EMPTY, VTS_BOOL)
	DISP_FUNCTION(CWilburDoc, "SearchForEx", oleSearchForEx, VT_DISPATCH, VTS_BSTR VTS_DISPATCH)
	DISP_FUNCTION(CWilburDoc, "ChangeDrive", oleChangeDrive, VT_BOOL, VTS_I2)
	DISP_FUNCTION(CWilburDoc, "SetZipEncrypt", oleSetZipEncrypt, VT_BOOL, VTS_BSTR VTS_BSTR VTS_BOOL VTS_BOOL VTS_BOOL)
	DISP_FUNCTION(CWilburDoc, "GetZipEncryptFlags", oleGetZipEncryptFlags, VT_I4, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "Halt", oleHalt, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CWilburDoc, "IsThreadRunning", oleIsThreadRunning, VT_BOOL, VTS_NONE)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IWilburDoc to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the
//  dispinterface in the .ODL file.

// {D6C63E21-DEEF-11CF-9B6F-00006E23CF57}
static const IID IID_IWilburDoc =
{ 0xd6c63e21, 0xdeef, 0x11cf, { 0x9b, 0x6f, 0x0, 0x0, 0x6e, 0x23, 0xcf, 0x57 } };

BEGIN_INTERFACE_MAP(CWilburDoc, CDocument)
	INTERFACE_PART(CWilburDoc, IID_IWilburDoc, Dispatch)
END_INTERFACE_MAP()

// {D6C63E22-DEEF-11CF-9B6F-00006E23CF57}
IMPLEMENT_OLECREATE(CWilburDoc, "Wilbur.FileIndex", 0xd6c63e22, 0xdeef, 0x11cf, 0x9b, 0x6f, 0x0, 0x0, 0x6e, 0x23, 0xcf, 0x57)

/*
#define MY_IMPLEMENT_OLECREATE(class_name, external_name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
	AFX_DATADEF COleObjectFactory class_name::factory(class_name::guid, \
		RUNTIME_CLASS(class_name), TRUE, _T(external_name)); \
	AFX_COMDAT const AFX_DATADEF GUID class_name::guid = \
		{ l, w1, w2, { b1, b2, b3, b4, b5, b6, b7, b8 } }; \

MY_IMPLEMENT_OLECREATE(CWilburDoc, "Wilbur.FileIndex", 0xd6c63e22, 0xdeef, 0x11cf, 0x9b, 0x6f, 0x0, 0x0, 0x6e, 0x23, 0xcf, 0x57)
*/

/////////////////////////////////////////////////////////////////////////////
// CWilburDoc construction/destruction

CWilburDoc::CWilburDoc()
	:
		m_pFileListView( NULL ), m_pContentsView( NULL ), m_pCurrentDocFile( NULL ),
		m_bQuickView( FALSE ), m_bCanSetFile( TRUE ), m_bDoSave( FALSE ), m_bBeenNagged( false )
		
{
	// CG: The following block was added by the OLE Automation component.
	{
		EnableAutomation();
		AfxOleLockApp();
	}
	thisApp()->setDocument( this );
	m_nNear = regGetInt( HKEY_CURRENT_USER, "options", "near", 8 );
}

CWilburDoc::~CWilburDoc()
{
	if( m_pCurrentDocFile )
		delete m_pCurrentDocFile;

	// CG: The following line was added by the OLE Automation component.
	AfxOleUnlockApp();
}

BOOL CWilburDoc::OnNewDocument()
{
	if ( thisApp()->isThreadRunning() || !CDocument::OnNewDocument() )
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	m_fileIndex.clear();

	try
	{
		CString sIncludeFile( thisApp()->startDirectory() + "\\" + "includelist.txt" );
		CStdioFile includeFile( sIncludeFile, CFile::modeRead | CFile::shareDenyNone  );

		CString sLine;
		while( includeFile.ReadString( sLine ) )
		{
			int nLength = sLine.GetLength();
			if( nLength > 1 )
				m_fileIndex.addInclude( sLine );
		}
	}
	catch( CFileException* e )
	{
		e->Delete();			
	}
	/*
	m_fileIndex.addInclude( "*:\\*.txt" );
	m_fileIndex.addInclude( "*:\\*.doc" );
	m_fileIndex.addInclude( "*:\\*.wri" );
	m_fileIndex.addInclude( "*:\\*.htm*" );
	m_fileIndex.addInclude( "*:\\*.mbx" );
	m_fileIndex.addInclude( "*:\\*.msg" );
	*/
	// Kludge to avoid aborted index dialog from building index due to above includes
	// see the call to the index dialog too
	m_fileIndex.setTimeCreated( 1 );

	findViews();

	if( m_pFileListView ) m_pFileListView->clearList();
	setCurrentFile( "", FALSE );
	if( m_pContentsView )
		m_pContentsView->setAddedChars( m_fileIndex.getAddedChars() + m_fileIndex.getAddedTrailingChars() );
	
	// OnEditIndex();
	if( !thisApp()->isAutomated() )
		thisApp()->getMainFrame()->PostMessage( WM_COMMAND, ID_EDIT_INDEX, NULL );


	return TRUE;
}

BOOL CWilburDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if( m_pCurrentDocFile )
	{
		delete m_pCurrentDocFile;
		m_pCurrentDocFile = NULL;
	}
	
	m_sDocFileName = lpszPathName;
	
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	if( m_pFileListView ) m_pFileListView->GetListCtrl().DeleteAllItems();
	if( m_pContentsView ) m_pContentsView->emptyBuffer();
	
	try
	{
		m_pCurrentDocFile = new CFile( m_sDocFileName, CFile::modeRead | CFile::shareDenyWrite );
	}
	catch( ... )
	{
		m_pCurrentDocFile = NULL;
	}

	return TRUE;
}

BOOL CWilburDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	if( m_pCurrentDocFile )
	{
		delete m_pCurrentDocFile;
		m_pCurrentDocFile = NULL;
	}

	m_sDocFileName = lpszPathName;
	
	BOOL bReturn = CDocument::OnSaveDocument(lpszPathName);

	try
	{
		m_pCurrentDocFile = new CFile( m_sDocFileName, CFile::modeRead | CFile::shareDenyWrite );
	}
	catch( ... )
	{
		m_pCurrentDocFile = NULL;
	}

	return bReturn;
}

/////////////////////////////////////////////////////////////////////////////
// CWilburDoc serialization

void CWilburDoc::Serialize(CArchive& ar)
{
	CObject::Serialize( ar );
	m_fileIndex.Serialize( ar );

	findViews();

	LOGFONT lf;
	if( ar.IsStoring() )
	{
		ar << (DWORD) 7; // release number
		ar << (BYTE) m_bQuickView;

		if( m_pFileListView && m_pFileListView->getFont( lf ) )
		{
			ar << (DWORD) 1;
			ar.Write( &lf, sizeof( lf ) );
		}
		else
			ar << (DWORD) 0;

		if( m_pContentsView && m_pContentsView->getFont( lf ) )
		{
			ar << (DWORD) 1;
			ar.Write( &lf, sizeof( lf ) );
		}
		else
			ar << (DWORD) 0;

	}
	else
	{
		if( m_pContentsView )
		{
			m_pContentsView->setInternationalFlag( m_fileIndex.getInternationalChar() );
			m_pContentsView->setOEMTextFlag( m_fileIndex.getOEMTextChar() );
			m_pContentsView->setNumberInclusion( m_fileIndex.getNumberInclusion() );
		}

		DWORD dwFlag;
		ar >> dwFlag;

		if( dwFlag > 7 )
			AfxThrowArchiveException( CArchiveException::badSchema );

		if( dwFlag > 1 )
		{
			if( dwFlag < 7 )
			{
				DWORD dwFileTime;
				ar >> dwFileTime;  // obsolete time used for shareware
			}
		} 	

		if( dwFlag > 0 )
		{
			if( dwFlag < 5 )
			{
				CList< CString, CString& > oldSearchHistory;
				oldSearchHistory.Serialize( ar );
				oldSearchHistory.RemoveAll();
				oldSearchHistory.Serialize( ar );  // get rid of file mask history
			}

			if( dwFlag < 6 )
			{
				BYTE bSoundex;
				ar >> bSoundex;
			}

			if( dwFlag > 2 )
			{
				BYTE bQuick;
				ar >> bQuick;
				m_bQuickView = bQuick;
			}
		}
			
		DWORD dwFont;
		ar >> dwFont;
		if( dwFont )
		{
			ar.Read( &lf, sizeof( lf ) );
			if( m_pFileListView )
				m_pFileListView->setFont( lf );
		}

		ar >> dwFont;
		if( dwFont )
		{
			ar.Read( &lf, sizeof( lf ) );
			if( m_pContentsView )
				m_pContentsView->setFont( lf );
		}


		if( dwFlag > 3 && dwFlag < 7 )
		{
			CString sRegName;
			ar >> sRegName;
		}

		if( m_pContentsView )
			m_pContentsView->setAddedChars( m_fileIndex.getAddedChars() + m_fileIndex.getAddedTrailingChars() );
	}
}

void CWilburDoc::findViews()
{
	for( POSITION pos = GetFirstViewPosition(); pos; )
	{
		CView* pView = GetNextView( pos );

		if( pView->IsKindOf( RUNTIME_CLASS( CFileListView ) ) )
			m_pFileListView = (CFileListView*) pView;
		else if( pView->IsKindOf( RUNTIME_CLASS( CContentsView ) ) )
			m_pContentsView = (CContentsView*) pView;
		else
			ASSERT( 0 );
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWilburDoc diagnostics

#ifdef _DEBUG
void CWilburDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWilburDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWilburDoc commands

CWinThread* CWilburDoc::runBuild()
{
	if( !thisApp()->isThreadRunning() )
	{
		if( m_pFileListView )
			m_pFileListView->clearList();

		return AfxBeginThread( indexThread,  &m_fileIndex, THREAD_PRIORITY_LOWEST );
	}
	else
		return NULL;
}

void CWilburDoc::OnIndexBuild() 
{
	if( runBuild() && thisApp()->getMainFrame() )
	{
		thisApp()->getMainFrame()->GetWindowText( m_sSavedTitle );
		CString sText;
		sText.LoadString( IDS_INDEXING );
		thisApp()->getMainFrame()->SetWindowText( sText + m_sSavedTitle );
	}
}

void CWilburDoc::OnUpdateIndexBuild(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !thisApp()->isThreadRunning() );	
}

void CWilburDoc::indexingFinished()
{
	Sleep( 100 ); // let thread finish
	if( thisApp()->getMainFrame() )
	{
		CWnd* pFrame = thisApp()->getMainFrame();
		pFrame->SetWindowText( m_sSavedTitle );

		if( pFrame->IsIconic() )
		{
			WINDOWPLACEMENT windowPlacement;
			if( pFrame->GetWindowPlacement( &windowPlacement ) )
			{
				windowPlacement.showCmd = SW_RESTORE;
				pFrame->SetWindowPlacement( &windowPlacement );
			}
		}
	}

	if( m_bDoSave )
	{
		char currentDir[ MAX_PATH ];
		GetCurrentDirectory( MAX_PATH, currentDir );

		m_bDoSave = FALSE;
		thisApp()->changeToIndexDirectory();
		DoFileSave();
		SetCurrentDirectory( currentDir );
	}

	OnIndexSearch();
}

CWinThread* CWilburDoc::runUpdate()
{
	if( !thisApp()->isThreadRunning() )
	{
		// BOOL bIsRegistered = thisApp()->isRegistered();

		DWORD dwTime = regGetInt( HKEY_LOCAL_MACHINE, "Settings", "IDNumber", 0 );
		dwTime ^= 0xADADADAD;
		__asm rol dwTime,15

/*
		if( !bIsRegistered )
		{
			CTime timeNow = CTime::GetCurrentTime();
			CTimeSpan tsInstalled( timeNow.GetTime() - dwTime );
			if( tsInstalled.GetDays() > 30 || tsInstalled.GetTotalSeconds() < 0 ||
				m_fileIndex.timeCreated() > timeNow )
			{
				simpleMessageBox("The evaluation period has expired\nUpdating indexes is no longer allowed" );
				return NULL;
			}
		}
*/
		if( m_pFileListView ) m_pFileListView->clearList();

		return AfxBeginThread( updateThread,  &m_fileIndex, THREAD_PRIORITY_LOWEST );
	}
	else
		return NULL;
}

void CWilburDoc::OnIndexUpdate() 
{
	if( thisApp()->getMainFrame() && m_fileIndex.mapsModified() )
	{
		if( simpleMessageBox( IDS_MUSTBUILD, MB_YESNO ) != IDYES )
			return;
	}

	if( runUpdate() && thisApp()->getMainFrame() )
	{
		thisApp()->getMainFrame()->GetWindowText( m_sSavedTitle );
		CString sText;
		sText.LoadString( IDS_UPDATING );
		thisApp()->getMainFrame()->SetWindowText( sText + m_sSavedTitle );
	}
}

void CWilburDoc::OnUpdateIndexUpdate(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !thisApp()->isThreadRunning() );
}

void CWilburDoc::OnIndexSearch() 
{
	doSearch();
}

void CWilburDoc::doSearch( BOOL bUseDialog )
{
	if( !thisApp()->isThreadRunning() )
	{
		if( bUseDialog )
		{
			CSearchDialog dlg;
			dlg.m_pDocument = this;
			dlg.m_pCriteria = &(thisApp()->searchCriteria());

			if( m_sSearchText.IsEmpty() )
				dlg.m_sSearch   = regGetString( HKEY_CURRENT_USER, "Search History", "Search_0", "" );
			else
				dlg.m_sSearch   = m_sSearchText;

			dlg.m_sStatus = getIndexAttributes();

			if( dlg.DoModal() == IDOK )
			{
				if( !dlg.m_sIndex.IsEmpty() )
				{
					thisApp()->searchNewIndex( dlg.m_sIndex, dlg.m_sSearch );
					return;
				}

				m_sSearchText = dlg.m_sSearch;

				addSearchText( m_sSearchText );

				searchFor( m_sSearchText, thisApp()->searchCriteria() );
			}
		}
		else
		{
			addSearchText( m_sSearchText );
			// addFileMask( m_sFileMask );

			searchFor( m_sSearchText, thisApp()->searchCriteria() );
		}

		UpdateAllViews( NULL );
	}
}

CString CWilburDoc::getIndexAttributes()
{
	CString sAttrib;

	CTime timeCreated = m_fileIndex.timeCreated();

	if( timeCreated == 0 )
		sAttrib.LoadString( IDS_OPTION_NOBUILD );
	else
	{
		sAttrib.LoadString( IDS_LAST_INDEXED );
		sAttrib = timeCreated.Format( sAttrib );
	}

	CString sNumber;
	switch( m_fileIndex.getNumberInclusion() )
	{
		case CFileIndex::noNumbers:
			sNumber.LoadString( IDS_NONUMBERS );
			break;

		case CFileIndex::trailingNumbers:
			sNumber.LoadString( IDS_NOSTARTNUMBERS );
			break;

		case CFileIndex::allNumbers:
			sNumber.LoadString( IDS_NUMBERSANYWHERE );
			break;
	}
	sAttrib += sNumber;
	sAttrib += '\n';

	CString sChar;
	if( m_fileIndex.getInternationalChar() )
		sChar.LoadString( IDS_INTLCHAR );
	else
		sChar.LoadString( IDS_ENGCHAR );

	sAttrib += sChar;

	CString sAdded = m_fileIndex.getAddedChars();
	if( !sAdded.IsEmpty() )
		sAttrib += " + \"" + sAdded + '\"';


	sAdded = m_fileIndex.getAddedTrailingChars();
	if( !sAdded.IsEmpty() )
		sAttrib += " + \"" + sAdded + '\"';

	sAdded.Format(IDS_MIN_MAX_WORD_FMT,
		m_fileIndex.getMinWordLength(), m_fileIndex.getMaxWordLength() );

	sAttrib += sAdded;

	return sAttrib;
}

CString CWilburDoc::getPassword( bool& bSave, bool& bEncryptNew, bool& bRestrictCopies )
{
	return m_fileIndex.getPassword( bSave, bEncryptNew, bRestrictCopies );
}

void CWilburDoc::OnUpdateIndexSearch(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !thisApp()->isThreadRunning() );
}

BOOL CWilburDoc::fileNameMatch( const char* pszFilePath, const char* pszFileMask )
{
	if( termMatch( pszFilePath, pszFileMask ) )
	{
		if( *pszFileMask == '^' ) pszFileMask++;  // step over beginning not if there

		// look for not
		while( *pszFileMask && *pszFileMask != '^' && *pszFileMask != '&' )
			pszFileMask++;

		if( *pszFileMask == '&' )
		{
			*pszFileMask++;
			while( *pszFileMask == ' ' ) pszFileMask++;
		}

		if( *pszFileMask )
		{
			return fileNameMatch( pszFilePath, pszFileMask );
		}

		return TRUE;
	}

	// check for OR clause
	while( *pszFileMask && *pszFileMask != '|' )
		pszFileMask++;

	if( *pszFileMask != '|' )
		return FALSE;

	pszFileMask++;
	while( *pszFileMask == ' ' ) pszFileMask++;

	return fileNameMatch( pszFilePath, pszFileMask );
}

BOOL CWilburDoc::termMatch( const char* pszFilePath, const char* pszFileMask )
{
	BOOL bTrueResult = TRUE;
	if( *pszFileMask == '^' )
	{
		pszFileMask++;
		while( *pszFileMask == ' ') pszFileMask++;

		bTrueResult = FALSE;
	}

	while( *pszFilePath )
	{
		if( *pszFileMask == '*' )
		{
			char c1, c2;
			c1 = makeLower( *++pszFileMask );
			do
			{
				c2 = makeLower( *pszFilePath );
				if( c2 == c1 && termMatch( pszFilePath, pszFileMask ) )
					return bTrueResult;
				pszFilePath++;
			} while( *pszFilePath );

			break;
		}
		else if( *pszFileMask == '?' || makeLower( *pszFilePath ) == makeLower( *pszFileMask ) )
		{
			*pszFilePath++;
			*pszFileMask++;
		}
		else
			break;
	}

	// trim trailing wildcards from mask
	if( *pszFilePath == '\0' )
		while( *pszFileMask == '*' || *pszFileMask == '?' )
			pszFileMask++;

	// trim right blanks from mask
	while( *pszFileMask == ' ' )
		*pszFileMask++;

    char c = *pszFileMask++;

	if( ( c == '\0' && *pszFilePath == '\0' ) ||
		( c == '*' && *pszFileMask == '\0' )  ||
		  c == '|' ||
		  c == '&' ||
		  c == '^' )
		return bTrueResult;
	else
		return !bTrueResult;
}

BOOL CWilburDoc::parenOK( const CString& sText )
{
	int nParen = 0;
	const char* pText = sText;
	char c;
	char cPrev = '\0';

	while( (c = *pText++ ) )
	{
		if( c == '(' )
		{
			if( *pText == '&' || *pText == '|' || *pText == '^' )
			{
				simpleMessageBox( IDS_SEARCH_PHRASE_ERR );
				return FALSE;
			}

			nParen++;
		}
		else if( c == ')' )
		{
			nParen--;
			if( nParen < 0 )
			{
				simpleMessageBox( IDS_RIGHT_PAREN_ERR );
				return FALSE;
			}

			if( cPrev == '&' || cPrev == '|' || cPrev == '^' )
			{
				simpleMessageBox( IDS_SEARCH_PHRASE_ERR );
				return FALSE;
			}
		}
		else if( c == '<' || c == '>' || c == ':' )
		{
			if( *pText == '(' || cPrev == ')' )
				simpleMessageBox( IDS_NEAR_PAREN_ERR );

			if( *pText == ')' || cPrev == '(' )
			{
				simpleMessageBox( IDS_SEARCH_PHRASE_ERR );
				return FALSE;
			}
		}

		if( c != ' ' )
			cPrev = c;
	}

	if( nParen )
	{
		simpleMessageBox( IDS_MISSING_RIGHT_PAREN );
		return FALSE;
	}

	return TRUE;
}

void CWilburDoc::removeExtras( CString sSearchText, CSearchResults& results )
{
	ASSERT( m_pContentsView );
	m_pContentsView->parseSearchText( sSearchText );
	if( sSearchText.FindOneOf("<>:") == -1 )
		return;

	bool bHasFrame = thisApp()->getMainFrame() != NULL;

	int nTotal = results.GetCount();
	
	CString sStatus;
	int nCount = 1;

	for( POSITION pos = results.GetStartPosition(); pos; nCount++ )
	{
		CFileResult fileResult;
		CFileInfo* pInfo;
		results.GetNextAssoc( pos, pInfo, fileResult );

		char*  pszName = pInfo->m_pszName;

		if( bHasFrame )
		{
			sStatus.Format( IDS_CHECKING_NEAR_FMT, pszName, nCount, nTotal );
	 		thisApp()->setStatus( sStatus );

			if( thisApp()->getHaltStatus() )
				AfxThrowUserException();
		}

		CString sPath;
		if( fileResult.m_pDirInfo )
			sPath = fileResult.m_pDirInfo->m_pszName;

		sPath += pInfo->m_pszName;

		if( !m_pContentsView->containsHit( sPath, sSearchText, thisApp()->searchCriteria().getSoundex() ) )
			results.RemoveKey( pInfo );
	}
}

void CWilburDoc::searchFor( const CString& sSearchText, CSearchCriteria& criteria )
{
	if( thisApp()->isThreadRunning() )
		return;

	CWaitCursor wait;
	m_bCanSetFile = FALSE;  // avoid unnecessary file sets while list is built

	CString sStatus;
	sStatus.LoadString( IDS_SEARCHING_FOR );
	sStatus += " ( " + sSearchText + " )";
	thisApp()->setStatus( sStatus );

	CString sTerminator( ",\t&|<^" );
	if( sSearchText.FindOneOf( sTerminator ) != 0 || m_fileIndex.isValidAlpha( sSearchText[0] ) )
	{
		m_results.RemoveAll();  // leave last results if operator starts search
		m_results.InitHashTable( m_fileIndex.numberOfFiles() * 13 / 10 );
	}

	try
	{
		if( parenOK( sSearchText ) )
		{
			CString sLower = makeLower( sSearchText );
			m_fileIndex.find( sLower, criteria, m_results );
			removeExtras( sLower, m_results );
			CString sSkipped = m_fileIndex.skippedWords();
			if( !sSkipped.IsEmpty() )
			{
				CString sAction;
				sAction.LoadString(IDS_SKIPPED );
				sStatus += sAction + sSkipped + " )";
				thisApp()->setStatus( sStatus );
			}

			if( m_results.IsEmpty() )
			{
				CString sFiles;
				sFiles.LoadString( IDS_NO_FILES_FOUND );
				sStatus += sFiles;
				thisApp()->setStatus( sStatus );
				MessageBeep( MB_ICONEXCLAMATION );
			}
		}
	}
	catch( ... )
	{
		simpleMessageBox( IDS_SEARCH_INTERRUPTED );
	}
	
	try
	{
		m_pFileListView->clearList();
		m_pFileListView->setCount( m_results.GetCount() );

		for( POSITION pos = m_results.GetStartPosition(); pos; )
		{
			CFileResult fileResult;
			CFileInfo* pInfo;
			m_results.GetNextAssoc( pos, pInfo, fileResult );

			m_pFileListView->addFile( fileResult );
		}

		m_pFileListView->setActualListCount();
		m_pFileListView->sort();

		CString sFile;
		if( criteria.getReverse() )
			sFile = m_pFileListView->lastFile();
		else
			sFile  = m_pFileListView->firstFile();

		m_bCanSetFile = TRUE;  // now explicitly set the file
		setCurrentFile( sFile, criteria.getReverse() );
	}
	catch( ... )
	{}
}

void CWilburDoc::setCurrentFile( const CString& sFile, BOOL bReverse )
{
	if( m_bCanSetFile == FALSE )
		return;

	CWaitCursor wait;

	m_sCurrentFile = sFile;
	
	CString sStatus = sFile;
	sStatus.MakeReverse();
	sStatus = sStatus.SpanExcluding( "\\/:" );
	sStatus.MakeReverse();

	m_pContentsView->newFileSelected();

	if( bReverse )
		m_pContentsView->setCursorToEnd();

	CString sFindStatus;
	if( !sFile.IsEmpty() )
	{
		if( !m_pContentsView->find( m_sSearchText, thisApp()->searchCriteria().getSoundex(), bReverse ) )
		{
			CString sNotFound; sNotFound.LoadString( IDS_NEXT_FILE );
			sFindStatus = " - " + sNotFound;
		}
	}

	WIN32_FIND_DATA fileData;
	HANDLE hFind = FindFirstFile( (const char*) sFile, &fileData );
	if( hFind != INVALID_HANDLE_VALUE )
	{
		CTime timeLastWritten( fileData.ftLastWriteTime );
		
		// after switching to memory mapped files it is no longer possible
		// to update the times on the fly due to the read only permissions
		// This may have been confusing anyway, since people would not
		// understand why they were asked to save the index - I didn't
		//if( m_fileIndex.setFileTime( sFile, timeLastWritten ) )
		//	SetModifiedFlag( TRUE );

		CString sTemp; sTemp.LoadString( IDS_STATUS_MOD );
		CString sFormat; sFormat.LoadString(IDS_DATETIMEFORMAT);
		sStatus += sTemp,
			sStatus += timeLastWritten.Format( sFormat );

		sTemp.LoadString( IDS_STATUS_SIZE );
		sStatus += sTemp;
		
		if( fileData.nFileSizeHigh )
		{
			sTemp.LoadString( IDS_STATUS_GIGANTIC );
			sStatus += sTemp;
		}
		else
		{
			CString sSize;
			sSize.Format( "%ld", fileData.nFileSizeLow );
			sStatus += sSize;
		}

		sTemp.LoadString( IDS_STATUS_ATTRIBUTES );
		sStatus += sTemp;

		if( fileData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN )
			sStatus += 'h';

		if( fileData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM )
			sStatus += 's';

		if( fileData.dwFileAttributes & FILE_ATTRIBUTE_READONLY )
			sStatus += 'r';

		if( fileData.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE )
			sStatus += 'a';

		CString sFileNumber;
		sFileNumber.Format(IDS_STATUS_FILENO_FMT, m_pFileListView->getCurrentIndex() + 1,
			                  m_pFileListView->GetListCtrl().GetItemCount() );
		sStatus += sFileNumber;

		FindClose( hFind );
	}

	if( !sStatus.IsEmpty() || !sFindStatus.IsEmpty() )
		thisApp()->setStatus( sStatus + sFindStatus );

	//if( m_bQuickView )
	//	quickView();
}

CString CWilburDoc::getCurrentFile()
{
	return m_sCurrentFile;
}

CString CWilburDoc::getContentsPath()
{
	if( !m_pContentsView->getTempZipName().IsEmpty() )
		return m_pContentsView->getTempZipName();
	else
		return m_sCurrentFile;
}

void CWilburDoc::markFileObsolete( FileID nFile )
{
	m_fileIndex.markFileObsolete( nFile );
	SetModifiedFlag(TRUE);
}

FileID CWilburDoc::getFileIDFromPath( const CString& sPath )
{
	return m_fileIndex.getFileIDFromPath( sPath );
}

CString CWilburDoc::getSearchText()
{
	return m_sSearchText;
}

BOOL CWilburDoc::getHaltStatus()
{
	MSG msg;
	return PeekMessage( &msg, m_pContentsView->m_hWnd, WM_LBUTTONDOWN, WM_LBUTTONDOWN, PM_NOREMOVE ) 
	    || PeekMessage( &msg, m_pFileListView->GetListCtrl().m_hWnd, WM_LBUTTONDOWN, WM_LBUTTONDOWN, PM_NOREMOVE )
	    || PeekMessage( &msg, m_pContentsView->m_hWnd, WM_KEYDOWN, WM_KEYDOWN, PM_NOREMOVE ) 
	    || PeekMessage( &msg, m_pFileListView->GetListCtrl().m_hWnd, WM_KEYDOWN, WM_KEYDOWN, PM_NOREMOVE );
}

void CWilburDoc::setTabSize( int nSize )
{
	m_pContentsView->setTabSize( nSize );
}

void CWilburDoc::setWordWrap( int nChar )
{
	m_pContentsView->setWordWrap( nChar );
}

void CWilburDoc::refreshContents()
{
	m_pContentsView->newFileSelected();
}

void CWilburDoc::setSearchText( CString& sText )
{
	m_sSearchText = sText;
	addSearchText( sText );
}

void CWilburDoc::addSearchText( CString& sText )
{
	CList< CString, CString& > searchHistory;
	readSearchHistory( searchHistory );

	int nItems = searchHistory.GetCount();
	if( nItems && searchHistory.GetHead() == sText )
		return;

	searchHistory.AddHead( sText );
	while( searchHistory.GetCount() > 20 )
		searchHistory.RemoveTail();

	writeSearchHistory( searchHistory );

	// SetModifiedFlag( TRUE );
}

void CWilburDoc::readSearchHistory( CList< CString, CString& > &searchHistory )
{
	int nItems = regGetInt( HKEY_CURRENT_USER, "Search History", "Count", 0 );
	
	for( int i = 0; i < nItems; i++ )
	{
		CString sItem;
		sItem.Format("Search_%d", i );
		CString sSearch = regGetString( HKEY_CURRENT_USER, "Search History", sItem, "" );
		searchHistory.AddTail( sSearch );
	}
}

void CWilburDoc::writeSearchHistory( CList< CString, CString& > &searchHistory )
{
	
	CString sItem = "Search_";
	int nItems = 0;
	for( POSITION pos = searchHistory.GetHeadPosition(); pos; )
	{
		CString sItem;
		sItem.Format("Search_%d", nItems++ );
		CString sText = searchHistory.GetNext( pos );
		regPutString( HKEY_CURRENT_USER, "Search History", sItem, sText );
	}

	regPutInt( HKEY_CURRENT_USER, "Search History", "Count", nItems );
}

void CWilburDoc::minimizeWindow()
{
	if( thisApp()->getMainFrame() )
	{
		CWnd* pFrame = thisApp()->getMainFrame();

		if( !pFrame->IsIconic() )
		{
			WINDOWPLACEMENT windowPlacement;
			if( pFrame->GetWindowPlacement( &windowPlacement ) )
			{
				windowPlacement.showCmd = SW_MINIMIZE;
				pFrame->SetWindowPlacement( &windowPlacement );
			}
		}
	}
}

void CWilburDoc::setFocusOnList()
{
	ASSERT_VALID( m_pFileListView );
	m_pFileListView->SetFocus();
}

void CWilburDoc::setFocusOnContents()
{
	ASSERT_VALID( m_pContentsView );
	m_pContentsView->SetFocus();
}

void CWilburDoc::OnIndexFindnext() 
{
	findNext( FALSE );
}

void CWilburDoc::OnUpdateIndexFindnext(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !thisApp()->isThreadRunning() );
}

// hmmm ... would have been nice if function names were more consistent (sigh)
void CWilburDoc::OnSearchFindprevious() 
{
	findNext( TRUE );
}

void CWilburDoc::OnUpdateSearchFindprevious(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !thisApp()->isThreadRunning() );
}

void CWilburDoc::findNext( BOOL bReverse )
{
	CWaitCursor wait;
	CString sMsg;
	sMsg.LoadString( IDS_SEARCHING_CLICK );
	thisApp()->setStatus( sMsg );
	
	BOOL bFound;
	while( !(bFound = m_pContentsView->find( m_sSearchText, thisApp()->searchCriteria().getSoundex(), bReverse ) ) )
	{
		if( thisApp()->getHaltStatus() )
			break;
		
		BOOL bNewFile;
		if( bReverse)
		{
			bNewFile = viewPrevious();
			if( bNewFile )
				m_pContentsView->setCursorToEnd();
		}
		else
			bNewFile = viewNext();

		if( !bNewFile )
			break;

		// do window updates so some repainting can be done 
		m_pFileListView->GetListCtrl().UpdateWindow();
		m_pContentsView->UpdateWindow();
		thisApp()->getMainFrame()->UpdateWindow();
	}

	if( bFound )
	{
		CString sMsg;
		sMsg.LoadString( IDS_NEXT_OCCURRENCE );
		thisApp()->setStatus( m_sSearchText + sMsg );
	}
	else
	{
		CString sMsg;
		sMsg.LoadString( IDS_NEXT_FILE );
		thisApp()->setStatus( sMsg );
		MessageBeep( MB_ICONEXCLAMATION );
	}
}

void CWilburDoc::OnEditIndex() 
{
	if( !thisApp()->isThreadRunning() )
	{
		
		CPropertySheet    propSheet( IDS_INDEX_PROPERTIES );
		CIndexFilesPage   includePage( IDS_INCLUDEFILES );
		CIndexFilesPage   excludePage( IDS_EXCLUDEFILES );
		CIndexOptionsPage optionPage;
		CIndexLanguagePage languagePage;
		CIndexEncrypt encryptPage;

		includePage.m_pDocument= this;
		includePage.m_pIndex = &m_fileIndex;

		excludePage.m_pDocument= this;
		excludePage.m_pIndex = &m_fileIndex;

		optionPage.m_pIndex = &m_fileIndex;
		optionPage.m_bUseZip  = m_fileIndex.getZipStatus();
		optionPage.m_bTrackAll = m_fileIndex.getTrackAll();
		optionPage.m_bUseRanking = m_fileIndex.getUseRanking();
		optionPage.m_nNumber  = m_fileIndex.getNumberInclusion();

		DWORD dwChar = m_fileIndex.getInternationalChar();
		languagePage.m_bInternationalChar = ( dwChar & CHAR_ALL ) ? true : false;
	    languagePage.m_bDanish  = dwChar & ( CHAR_DANISH ) ? true : false;
	    languagePage.m_bFinnish = dwChar & ( CHAR_FINNISH ) ? true : false;
	    languagePage.m_bFrench  = dwChar & ( CHAR_FRENCH ) ? true : false;
	    languagePage.m_bGerman  = dwChar & ( CHAR_GERMAN ) ? true : false;
	    languagePage.m_bSpanish = dwChar & ( CHAR_SPANISH ) ? true : false;
	    languagePage.m_bSwedish = dwChar & ( CHAR_SWEDISH ) ? true : false;
		languagePage.m_sSkipFile = m_fileIndex.getSkipFile();
		languagePage.m_bOEMChar = m_fileIndex.getOEMTextChar();

		optionPage.m_sAddedChars = m_fileIndex.getAddedChars();
		optionPage.m_sAddedTrailing = m_fileIndex.getAddedTrailingChars();
		optionPage.m_nMinWordLength = m_fileIndex.getMinWordLength();
		optionPage.m_nMaxWordLength = m_fileIndex.getMaxWordLength();

		bool bStore, bEncryptNew, bRestrictCopies;
		CString sPassword = m_fileIndex.getPassword( bStore, bEncryptNew, bRestrictCopies );
		
		encryptPage.m_sPassword = sPassword;
		encryptPage.m_sPasswordCheck = sPassword;
		encryptPage.m_bStorePassword = bStore;
		encryptPage.m_bEncryptNew = bEncryptNew;
		encryptPage.m_bRestrictCopies = bRestrictCopies;

		propSheet.AddPage( &includePage );
		propSheet.AddPage( &excludePage );
		propSheet.AddPage( &optionPage );
		propSheet.AddPage( &languagePage );
		propSheet.AddPage( &encryptPage );

		int nDialogAction = propSheet.DoModal();

		if( nDialogAction != IDCANCEL )
		{
			dwChar = 0;
			if( languagePage.m_bInternationalChar ) dwChar |= CHAR_ALL;
			if( languagePage.m_bDanish )  dwChar |= CHAR_DANISH;
			if( languagePage.m_bFinnish ) dwChar |= CHAR_FINNISH;
			if( languagePage.m_bFrench )  dwChar |= CHAR_FRENCH;
			if( languagePage.m_bGerman )  dwChar |= CHAR_GERMAN;
			if( languagePage.m_bSpanish ) dwChar |= CHAR_SPANISH;
			if( languagePage.m_bSwedish ) dwChar |= CHAR_SWEDISH;

			m_fileIndex.setInternationalChar( dwChar );
			m_pContentsView->setInternationalFlag( dwChar );

			m_fileIndex.setOEMTextChar( languagePage.m_bOEMChar );
			m_pContentsView->setOEMTextFlag( languagePage.m_bOEMChar );

			m_fileIndex.setSkipFile( languagePage.m_sSkipFile );
	
			m_fileIndex.setZipStatus( optionPage.m_bUseZip );
			m_fileIndex.setTrackAll( optionPage.m_bTrackAll == TRUE );
			m_fileIndex.setUseRanking( optionPage.m_bUseRanking );
			m_fileIndex.setMinWordLength( optionPage.m_nMinWordLength );
			m_fileIndex.setMaxWordLength( optionPage.m_nMaxWordLength );

			int nNumber = optionPage.m_nNumber;
			if( nNumber != CB_ERR )
			{
				CFileIndex::NumberInclusion numberInclusion = (CFileIndex::NumberInclusion) nNumber;
				m_fileIndex.setNumberInclusion( numberInclusion );
				m_pContentsView->setNumberInclusion( numberInclusion );
			}

			m_fileIndex.setAddedChars( optionPage.m_sAddedChars, optionPage.m_sAddedTrailing );
			m_pContentsView->setAddedChars( optionPage.m_sAddedChars + optionPage.m_sAddedTrailing );

			if( !sPassword.IsEmpty() && bRestrictCopies && !encryptPage.m_bRestrictCopies &&
				 sPassword == encryptPage.m_sPassword )
			{
				CConfirmPassword confirmDlg;
				confirmDlg.m_sMessage.LoadString( IDS_PWCONFIRMRESTRICT );
				encryptPage.m_sPasswordCheck.Empty();
				if( confirmDlg.DoModal() != IDCANCEL )
					encryptPage.m_sPasswordCheck = confirmDlg.m_sPassword;
			}

			if( !encryptPage.m_sPassword.IsEmpty() &&
				!encryptPage.m_sPasswordCheck.IsEmpty() &&
				encryptPage.m_sPassword != encryptPage.m_sPasswordCheck )
			{
				simpleMessageBox( IDS_CONFIRM_PW_ERR );
			}
			else
			{
				m_fileIndex.setPassword( encryptPage.m_sPassword,
										 encryptPage.m_bStorePassword == TRUE,
										 encryptPage.m_bEncryptNew == TRUE,
										 encryptPage.m_bRestrictCopies == TRUE );
			}

			// kludge to avoid building index on ESC with default files added from new index
			if( m_fileIndex.timeCreated() == 1 )
				m_fileIndex.setTimeCreated( 0 );


			if( m_fileIndex.timeCreated() == 0 )
			{
				if( simpleMessageBox( IDS_DO_BUILD, MB_YESNO ) == IDYES )
					OnIndexBuild();
			}
		}
	}
}

void CWilburDoc::OnUpdateEditIndex(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !thisApp()->isThreadRunning() );
}

void CWilburDoc::DeleteContents() 
{
	m_fileIndex.clear();
	
	CDocument::DeleteContents();
}


void CWilburDoc::OnFileEdit() 
{
	if( m_pFileListView )
		m_pFileListView->editTextFile();
}

void CWilburDoc::OnUpdateFileEdit(CCmdUI* pCmdUI) 
{
	if( m_pFileListView )
	{
		bool bEnable = ( m_pFileListView->GetListCtrl().GetSelectedCount() == 1 );

		CString sLower = makeLower( m_sCurrentFile );
		bEnable = ( bEnable && CFileIndex::getZipExtIndex(sLower) == -1 );

		pCmdUI->Enable( bEnable );
	}
}

void CWilburDoc::OnFileLaunch() 
{
	if( m_pFileListView )
		m_pFileListView->launchFile();	
}

void CWilburDoc::OnUpdateFileLaunch(CCmdUI* pCmdUI) 
{
	if( m_pFileListView )
		pCmdUI->Enable( m_pFileListView->GetListCtrl().GetSelectedCount() == 1 );
}

void CWilburDoc::OnFilePrint() 
{
	if( m_pFileListView )
		m_pFileListView->printFile();	
}

void CWilburDoc::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	if( m_pFileListView )
		pCmdUI->Enable( m_pFileListView->GetListCtrl().GetSelectedCount() == 1 );
}

BOOL CWilburDoc::CanCloseFrame(CFrameWnd* pFrame) 
{
	for(int i = 0; i < 10 && thisApp()->isThreadRunning(); i++)
		Sleep( 100 );

	if( thisApp()->isThreadRunning() )
	{
		MessageBeep( MB_ICONEXCLAMATION );
		if( simpleMessageBox( IDS_END_PROCESS_QUEST, MB_YESNO ) == IDNO )
			return FALSE;

		SetModifiedFlag( FALSE );
		thisApp()->setAutomated( TRUE );  // so there are no message boxes

		while( thisApp()->isThreadRunning() )
		{
			thisApp()->setHaltStatus( TRUE );
			Sleep( 100 );
		}
	
	}
	
	return CDocument::CanCloseFrame(pFrame);
}

void CWilburDoc::setNear( int nNear )
{
	m_nNear = nNear;
	regPutInt( HKEY_CURRENT_USER, "options", "near", m_nNear );
}

void CWilburDoc::OnSearchQuickfind() 
{
	if( m_pContentsView )
	{
		CString sWord = m_pContentsView->getCursorWord();
		if( !sWord.IsEmpty() )
		{
			m_sSearchText = sWord;
			OnIndexSearch();
		}
	}
}

void CWilburDoc::OnUpdateSearchQuickfind(CCmdUI* pCmdUI) 
{
	if( m_pContentsView )
		pCmdUI->Enable( !m_pContentsView->getCursorWord().IsEmpty() );
}

void CWilburDoc::OnEditSelectall() 
{
	CMainFrame* pWnd = thisApp()->getMainFrame();

	if( pWnd )
	{
		if( m_pFileListView && pWnd->GetActiveView() == m_pFileListView )
			m_pFileListView->selectAll();
		else if( m_pContentsView )
			m_pContentsView->selectAll();
	}
}

void CWilburDoc::OnViewFont() 
{
	CMainFrame* pWnd = thisApp()->getMainFrame();

	if( pWnd )
	{
		if( m_pFileListView && pWnd->GetActiveView() == m_pFileListView )
			m_pFileListView->changeFont();
		else if( m_pContentsView )
			m_pContentsView->changeFont();
	}
}

void CWilburDoc::OnViewQuick() 
{
	quickView();
}

void CWilburDoc::OnUpdateViewQuick(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !getContentsPath().IsEmpty() );
}


void CWilburDoc::OnViewAutoquick() 
{
	m_bQuickView = !m_bQuickView;
    if( m_bQuickView )
		quickView();
}

void CWilburDoc::OnUpdateViewAutoquick(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_bQuickView );
}

void CWilburDoc::OnViewInternational() 
{
	if( m_pContentsView )
	{
		CWaitCursor wait;
		
		m_pContentsView->setInternationalFlag(  CHAR_ALL ^ m_pContentsView->getInternationalFlag() );
		m_pContentsView->newFileSelected();
	}
}

void CWilburDoc::OnUpdateViewInternational(CCmdUI* pCmdUI) 
{
	if( m_pContentsView )
		pCmdUI->SetCheck( m_pContentsView->getInternationalFlag() & CHAR_ALL );
}

void CWilburDoc::OnViewOemtext() 
{
	if( m_pContentsView )
	{
		CWaitCursor wait;
		
		m_pContentsView->setOEMTextFlag( !m_pContentsView->getOEMTextFlag() );
		m_pContentsView->newFileSelected();
	}
}

void CWilburDoc::OnUpdateViewOemtext(CCmdUI* pCmdUI) 
{
	if( m_pContentsView && m_pContentsView->getInternationalFlag() )
	{
		pCmdUI->Enable( TRUE );
		pCmdUI->SetCheck( m_pContentsView->getOEMTextFlag() );
	}
	else
	{
		pCmdUI->Enable( FALSE );
		pCmdUI->SetCheck( FALSE );
	}
}

void CWilburDoc::OnViewOutline() 
{
	CWaitCursor wait;
	
	if( m_pContentsView )
		m_pContentsView->setOutline( !m_pContentsView->getOutline() );
}

void CWilburDoc::OnUpdateViewOutline(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
	if( m_pContentsView )
		pCmdUI->SetCheck( m_pContentsView->getOutline() );
}

void CWilburDoc::OnViewhidehtml() 
{
	CWaitCursor wait;
	
	if( m_pContentsView )
		m_pContentsView->setHideHtml( !m_pContentsView->getHideHtml() );
}

void CWilburDoc::OnUpdateViewhidehtml(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
	if( m_pContentsView )
		pCmdUI->SetCheck( m_pContentsView->getHideHtml() );
}

void CWilburDoc::OnViewNext() 
{
	viewNext();
}

BOOL CWilburDoc::viewNext()
{
	BOOL bQuickView = m_bQuickView;
	m_bQuickView = FALSE;  // turn off quickview for now
	CString sNextFile = m_pFileListView->nextFile();
	m_bQuickView = bQuickView;

	if( sNextFile.IsEmpty() )
		return FALSE;
	else
	{
		m_sCurrentFile = sNextFile;
		m_pContentsView->newFileSelected();
		return TRUE;
	}
}

void CWilburDoc::OnUpdateViewNext(CCmdUI* pCmdUI) 
{
	if( m_pFileListView )
		pCmdUI->Enable( !m_sCurrentFile.IsEmpty() &&
		m_pFileListView->getCurrentIndex() + 1 < m_pFileListView->GetListCtrl().GetItemCount() );
}

void CWilburDoc::OnViewPrev() 
{
	viewPrevious();
}

BOOL CWilburDoc::viewPrevious()
{
	CString sPrevFile = m_pFileListView->prevFile();
	if( sPrevFile.IsEmpty() )
		return FALSE;
	else
	{
		m_sCurrentFile = sPrevFile;
		m_pContentsView->newFileSelected();
		return TRUE;
	}
}

void CWilburDoc::quickView()
{
	CString sCommand = getContentsPath();

	if( !sCommand.IsEmpty() )
	{
		PROCESS_INFORMATION processInfo;
		STARTUPINFO startInfo;
		memset(	&startInfo, 0, sizeof( startInfo ) );
		startInfo.cb = sizeof( startInfo );
		startInfo.wShowWindow = SW_SHOW;

		sCommand = thisApp()->getQuickViewPath() + '"' + sCommand + '"';
		CreateProcess( NULL, sCommand.GetBuffer(256), NULL, NULL, FALSE, 0, NULL, NULL, 
			           &startInfo, &processInfo );

		WaitForInputIdle( processInfo.hProcess, 10000 );
		
		if( m_bQuickView )
		{
			CWnd* pMyFrame = thisApp()->getMainFrame();
			CWnd* pCurrentFrame;
			for( int i = 0; i < 20 &&
				pMyFrame == ( pCurrentFrame = CWnd::GetForegroundWindow()); i++ )
				Sleep( 100 );

			Sleep( 1000 );

			pMyFrame->SetForegroundWindow();
		}
	}
}

void CWilburDoc::OnUpdateViewPrev(CCmdUI* pCmdUI) 
{
	if( m_pFileListView )
		pCmdUI->Enable( !m_sCurrentFile.IsEmpty() && m_pFileListView->getCurrentIndex() > 0 );
}

void CWilburDoc::oleQuit() 
{
	CWnd* pWnd = thisApp()->getMainFrame();
	if( pWnd )
		pWnd->PostMessage( WM_COMMAND, ID_APP_EXIT );
}

BOOL CWilburDoc::oleOpenIndex(LPCTSTR sIndexPath) 
{
	m_sDocFileName = sIndexPath;
	
	thisApp()->setAutomated( TRUE );

	BOOL bReturn = OnOpenDocument( sIndexPath );

/*
	try
	{
		CFile f;
		if( f.Open( sIndexPath, CFile::modeRead ) )
		{
			CArchive ar( &f, CArchive::load );
			ar.m_pDocument = this;
			Serialize( ar );
			bReturn = TRUE;
		}
		else
			bReturn = FALSE;
	}
	catch ( ... )
	{
		bReturn = FALSE;
	}
*/

	thisApp()->setAutomated( FALSE );

	return bReturn;
}

LPDISPATCH CWilburDoc::oleSearchForEx(LPCTSTR sSearchString, LPDISPATCH pDispCriteria) 
{
	thisApp()->setAutomated( TRUE );
	m_sSearchText = sSearchString;
	m_sSearchText.MakeLower();

	CSearchResults* pResults = new CSearchResults;
	pResults->InitHashTable( m_fileIndex.numberOfFiles() * 13 / 10 );

	if( parenOK( sSearchString ) )
	{
		CSearchCriteria* pCriteria = (CSearchCriteria*)CCmdTarget::FromIDispatch(pDispCriteria);
		if (pCriteria != NULL && pCriteria->IsKindOf(RUNTIME_CLASS(CSearchCriteria)))
		{
			CString sLower = makeLower( sSearchString );
			m_fileIndex.find( sLower, *pCriteria, *pResults );
		}
	}

	CWilburResults* pOleResults = new CWilburResults();
	pOleResults->setSearchResults( pResults, this );
	thisApp()->setAutomated( FALSE );
	return pOleResults->GetIDispatch( FALSE );
}

LPDISPATCH CWilburDoc::oleSearchFor(LPCTSTR sSearchString) 
{
	thisApp()->setAutomated( TRUE );
	m_sSearchText = sSearchString;
	m_sSearchText.MakeLower();

	CSearchResults* pResults = new CSearchResults;
	pResults->InitHashTable( m_fileIndex.numberOfFiles() * 13 / 10 );

	if( parenOK( sSearchString ) )
	{
		CSearchCriteria criteria( false );
		CString sLower = makeLower( sSearchString );
		m_fileIndex.find( sLower, criteria, *pResults );
	}

	CWilburResults* pOleResults = new CWilburResults();
	pOleResults->setSearchResults( pResults, this );
	thisApp()->setAutomated( FALSE );
	return pOleResults->GetIDispatch( FALSE );
}

BOOL CWilburDoc::oleShowWindow() 
{
	return thisApp()->createMainFrame();// TODO: Add your dispatch handler code here

}

BOOL CWilburDoc::oleSaveIndex(LPCTSTR sIndexPath) 
{
	m_sDocFileName = sIndexPath;
	
	thisApp()->setAutomated( TRUE );

	BOOL bReturn;
	try
	{
		if( m_pCurrentDocFile )
		{
			delete m_pCurrentDocFile;
			m_pCurrentDocFile = NULL;
		}

		m_sDocFileName = sIndexPath;

		{
			CFile f;
			if( f.Open( sIndexPath, CFile::modeCreate | CFile::modeWrite ) )
			{
				CArchive ar( &f, CArchive::store );
				ar.m_pDocument = this;
				Serialize( ar );

				bReturn = TRUE;
			}
			else
			{
				DWORD nErr = GetLastError();

				char* pszMessage;
				FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
							   NULL, nErr, 0, (char*) &pszMessage, 10, NULL );
				simpleMessageBox( pszMessage );

				bReturn = FALSE;
			}
		}

		try
		{
			m_pCurrentDocFile = new CFile( m_sDocFileName, CFile::modeRead | CFile::shareDenyWrite );
		}
		catch( ... )
		{
			m_pCurrentDocFile = NULL;
		}

	}
	catch ( ... )
	{
		bReturn = FALSE;
	}

	thisApp()->setAutomated( FALSE );

	return bReturn;
}


BOOL CWilburDoc::oleBuild(long nWaitTime) 
{
	thisApp()->setAutomated( TRUE );
	CWinThread* pThread = runBuild();

	if( pThread && nWaitTime )
	{
		if( WaitForSingleObject( pThread->m_hThread, nWaitTime ) != WAIT_OBJECT_0 )
			return FALSE;
	}

	thisApp()->setAutomated( FALSE );
	return ( pThread != NULL );
}

BOOL CWilburDoc::oleUpdate(long nWaitTime) 
{
	thisApp()->setAutomated( TRUE );
	CWinThread* pThread = runUpdate();

	if( pThread && nWaitTime )
	{
		if( WaitForSingleObject( pThread->m_hThread, nWaitTime ) != WAIT_OBJECT_0 )
			return FALSE;
	}

	thisApp()->setAutomated( FALSE );
	return ( pThread != NULL );
}

void CWilburDoc::oleAddInclude(LPCTSTR sPath) 
{
	thisApp()->setAutomated( TRUE );
	m_fileIndex.addInclude( sPath );
	thisApp()->setAutomated( FALSE );
}

void CWilburDoc::oleAddExclude(LPCTSTR sPath) 
{
	thisApp()->setAutomated( TRUE );
	m_fileIndex.addExclude( sPath );
	thisApp()->setAutomated( FALSE );
}

void CWilburDoc::oleRemoveInclude(LPCTSTR sPath) 
{
	thisApp()->setAutomated( TRUE );
	m_fileIndex.removeInclude( sPath );
	thisApp()->setAutomated( FALSE );
}

void CWilburDoc::oleRemoveExclude(LPCTSTR sPath) 
{
	thisApp()->setAutomated( TRUE );
	m_fileIndex.removeExclude( sPath );
	thisApp()->setAutomated( FALSE );
}

BOOL CWilburDoc::oleChangeDrive(short driveNumber) 
{
	return (_chdrive( driveNumber ) == 0 );
}

void CWilburDoc::ClearIncludes() 
{
	thisApp()->setAutomated( TRUE );
	m_fileIndex.clearIncludes();
	thisApp()->setAutomated( FALSE );
}

void CWilburDoc::oleClearExcludes() 
{
	thisApp()->setAutomated( TRUE );
	m_fileIndex.clearExcludes();
	thisApp()->setAutomated( FALSE );
}

BSTR CWilburDoc::oleGetInclude(long nInclude) 
{
	CString strResult;
	thisApp()->setAutomated( TRUE );

	POSITION pos = m_fileIndex.getFirstInclude();
	while( pos && --nInclude > 0 )
		m_fileIndex.getNextInclude( pos );

	if( pos )
		strResult = m_fileIndex.getNextInclude( pos );

	thisApp()->setAutomated( FALSE );
	return strResult.AllocSysString();
}

BSTR CWilburDoc::oleGetExclude(long nExclude) 
{
	CString strResult;
	thisApp()->setAutomated( TRUE );

	POSITION pos = m_fileIndex.getFirstExclude();
	while( pos && --nExclude > 0 )
		m_fileIndex.getNextExclude( pos );

	if( pos )
		strResult = m_fileIndex.getNextExclude( pos );

	thisApp()->setAutomated( FALSE );
	return strResult.AllocSysString();
}

void CWilburDoc::oleSetNumberHandling(short nHandling) 
{
	m_fileIndex.setNumberInclusion( (CFileIndex::NumberInclusion) nHandling );
}

short CWilburDoc::oleGetNumberHandling() 
{
	return m_fileIndex.getNumberInclusion();
}

long CWilburDoc::oleGetInternational() 
{
	return m_fileIndex.getInternationalChar();
}

void CWilburDoc::oleSetInternational(long nInternational) 
{
	m_fileIndex.setInternationalChar( nInternational );
}


void CWilburDoc::oleSetDOSText(BOOL bDOSText) 
{
	m_fileIndex.setOEMTextChar( bDOSText );
}

BOOL CWilburDoc::oleGetDOSText() 
{
	return m_fileIndex.getOEMTextChar();
}


void CWilburDoc::oleSetAddedCharacters(LPCTSTR sAdded, LPCTSTR sTrailing) 
{
	m_fileIndex.setAddedChars( sAdded, sTrailing );
}

BSTR CWilburDoc::oleGetAddedCharacters() 
{
	CString strResult = m_fileIndex.getAddedChars();

	return strResult.AllocSysString();
}

BSTR CWilburDoc::oleGetAddedTrailing() 
{
	CString strResult = m_fileIndex.getAddedTrailingChars();

	return strResult.AllocSysString();
}

BOOL CWilburDoc::oleGetTrackAll() 
{
	return m_fileIndex.getTrackAll();
}

void CWilburDoc::oleSetTrackAll(BOOL bNewValue) 
{
	m_fileIndex.setTrackAll( bNewValue ? TRUE : FALSE );
}

BOOL CWilburDoc::oleGetZip() 
{
	return m_fileIndex.getZipStatus();
}

void CWilburDoc::oleSetZip(BOOL bZip) 
{
	m_fileIndex.setZipStatus( bZip );
}

BOOL CWilburDoc::oleSetZipEncrypt(LPCTSTR sOldPassword, LPCTSTR sNewPassword, BOOL bStorePassword, BOOL bEncryptNew, BOOL bRestrictCopying) 
{
	bool bOldStore, bOldEncryptNew, bOldRestrictCopying;
	CString sPassword = m_fileIndex.getPassword( bOldStore, bOldEncryptNew, bOldRestrictCopying );

	if( !sPassword.IsEmpty() && bOldRestrictCopying && !bRestrictCopying &&
		 sPassword != sOldPassword )
	{
		return FALSE;
	}

	m_fileIndex.setPassword( sNewPassword,
								bStorePassword == TRUE,
								bEncryptNew == TRUE,
								bRestrictCopying == TRUE );

	return TRUE;
}

long CWilburDoc::oleGetZipEncryptFlags() 
{
	bool bOldStore, bOldEncryptNew, bOldRestrictCopying;
	CString sPassword = m_fileIndex.getPassword( bOldStore, bOldEncryptNew, bOldRestrictCopying );

	long nFlags = (bOldStore) ? 4 : 0;
	nFlags += (bOldEncryptNew) ? 2 : 0;
	nFlags += (bOldRestrictCopying) ? 1 : 0;

	return nFlags;
}

long CWilburDoc::oleGetNumberOfFiles() 
{
	return m_fileIndex.numberOfFiles();
}

long CWilburDoc::oleGetNumberOfWords() 
{
	return m_fileIndex.numberOfWords();
}

long CWilburDoc::oleGetNumberOfBytes() 
{
	return m_fileIndex.numberOfBytes();
}

DATE CWilburDoc::oleGetTimeCreated() 
{
	COleDateTime oleDate = m_fileIndex.timeCreated().GetTime();

	return oleDate;
}

BOOL CWilburDoc::oleIsThreadRunning() 
{
	return thisApp()->isThreadRunning();
}

BSTR CWilburDoc::oleGetMessages() 
{
	CString strResult = m_sMessages;
	return strResult.AllocSysString();
}

void CWilburDoc::oleAddMessage(LPCTSTR pszMessage) 
{
	m_sMessages += pszMessage;
	m_sMessages += '\n';
}

void CWilburDoc::oleClearMessages() 
{
	m_sMessages.Empty();
}

void CWilburDoc::oleHalt() 
{
	thisApp()->setHaltStatus( true );
}

void CWilburDoc::OnFileSave() 
{
	char currentDir[ MAX_PATH ];
	GetCurrentDirectory( MAX_PATH, currentDir );

	thisApp()->changeToIndexDirectory();
	CDocument::OnFileSave();

	SetCurrentDirectory( currentDir );
}

void CWilburDoc::OnFileSaveAs() 
{
	char currentDir[ MAX_PATH ];
	GetCurrentDirectory( MAX_PATH, currentDir );

	thisApp()->changeToIndexDirectory();
	CDocument::OnFileSaveAs();

	SetCurrentDirectory( currentDir );
}


void CWilburDoc::OnWordCount() 
{
	CWordCountDialog dlg;

	if( dlg.DoModal() == IDOK )
	{
		CWaitCursor cursor;
		m_fileIndex.wordCount( dlg.m_sResultFile, dlg.m_dPercent );
	}
}

void CWilburDoc::OnImportSkip() 
{
	CFileDialog dlg( TRUE, "txt", "*.txt", OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR | OFN_SHOWHELP );

	if( dlg.DoModal() == IDOK )
	{
		m_fileIndex.importSkipWords( dlg.GetPathName() );
	}
}

